<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: User
|   > Script written by Alex Roxon
|   > Date started: May 15 2009
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

set_time_limit(240);

class User 
{
	var $class;
	var $return = array();
	var $Output;

	var $per_page = 15;
	var $min_length = 6;

	// User comments
	var $user_per_page = 5;

	// Reply variables
	var $wait_time = 30;
	var $rep_min_length = 15;

	var $WallpapersPerPage = 0;

	function run()
	{
		switch($this->class->Data("mode"))
		{
			case "guest_submit":
				return $this->guest_submit();
				break;
		}

		if($this->class->Settings['users_active'] != '1')
			header("Location: " . $this->class->Settings['Website_URL'] . "disabled.html");

		if (functions::check_logged() == true && array_key_exists('username', $this->class->User))
			$this->class->lang->Phrase['global_username'] = utf8_encode(strtolower(str_replace(array(' '), '-', $this->class->User['username'])));

		switch($this->class->Data("mode"))
		{
			case "email":
				return $this->email();
				break;
			case "signup_submit":
				return $this->submit_signup();
				break;
			case "signup":
				return $this->signup();
				break;
			case "show_comments":
				return $this->show_comments();
				break;
			case "user_comment":
				return $this->user_comment();
				break;
			case "view_user":
				return $this->view_user();
				break;
			case "new_message":
				return $this->new_message();
				break;
			case "reply_message":
				return $this->reply_message();
				break;
			case "show_message":
				return $this->show_message();
				break;
			case "show_messages":
				return $this->show_messages();
				break;
			case "inbox":
				return $this->inbox();
				break;
			case "pag":
				return $this->pag();
				break;
			case "show":
				return $this->show_walls();
				break;
			case "delete":
				return $this->delete();
				break;
			case "gallery":
				return $this->gallery();
				break;
			case "edit_account_submit":
				return $this->edit_account_submit();
				break;
			case "change_pass":
				return $this->change_pass();
				break;
			case "edit":
				return $this->edit();
				break;
			case "login":
				return $this->login_form();
				break;
			case "submit":
				return $this->submit_login();
				break;
			case "home":
				return $this->home();
				break;
			case "logout":
				return $this->logout();
				break;
			case "forgot":
				return $this->forgot();
				break;
		}
	
	}

	function guest_submit()
	{
		$this->return['path'] = "";

		if($this->class->Settings['guest_submit'] != 1)
			$this->class->Error( $this->class->lang->Phrase['feature_disabled'] );

		//-----------------------------------------------------------
		// What to do if we are adding a wallpaper.
		//-----------------------------------------------------------

		if ($this->class->Data("action") == "submit") 
			return $this->SubmitWallpaper(true, null);

		$this->class->page['title'] = $this->class->lang->Phrase['catSubmit'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		//-----------------------------------------------------------
		// Get the categories and subcategories
		//-----------------------------------------------------------

		$Query = "SELECT * FROM `categories`";
		$Res = $this->class->mysql->Query($Query);
		$Categories = $this->class->mysql->FetchResults($Res);

		$Structure = array();
		$Subs = array();
		foreach($Categories as $Cat) 
		{
			if ($Cat['parent'] == 0)
				$Structure[$Cat['id']] = array("name" => $Cat['name'], "Sub" => array());
			else $Subs[] = $Cat;
		}

		foreach($Subs as $Sub) 
			$Structure[$Sub['parent']]['Sub'][$Sub['id']] = $Sub['name'];

		asort($Structure);

		$Options = null;
		foreach($Structure as $id => $Cat)
		{
			$Options .= "<option value='".$id."'>".$Cat['name']."</option>\n";
			foreach($Cat['Sub'] as $sid => $scat)
				$Options .= "<option value='".$sid."'>&nbsp;&nbsp;&nbsp;- ".$scat."</option>\n";
		}

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['user_wall_warning'],
		));

		// Captcha on guest submit
		if(! empty($this->class->Settings['publickey']) && ! empty($this->class->Settings['privatekey']))
			$recaptcha = $this->class->Recaptcha->recaptcha_get_html($this->class->Settings['publickey']);
		else $recaptcha = null;

		//-----------------------------------------------------------
		// Lets output the user homepage
		//-----------------------------------------------------------

		$this->Output .= $this->class->template->LoadTemplate("login/user_home.cphp", array(
			"Options"		=> $Options,
			"min_length"	=> 3,
			"message"		=> $Message,
			"captcha"		=> $recaptcha,
		));

		if (functions::check_logged() == true) 
		{
			$comHTML = $this->Comments(5, $this->return['path']);
			$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
				"comments"		=> $comHTML,
			));
		} else
		{
			$this->Output .= $this->class->template->LoadTemplate("misc/login_box.cphp", array());
		}		

		return $this->Output;



	}

	//---------------------------------------------------------
    // Name:    signup_submit()
    // Desc:    Process the submit.
    //---------------------------------------------------------

	function submit_signup()
	{

		// Some basic information
		$this->return['path'] = "../";
		$this->class->page['title'] = $this->class->lang->Phrase['sign_title'] . " - ".$this->class->Settings['Site_Title'];

		// Are we already logged in?
		if (functions::check_logged() == true)
			$this->class->Error( $this->class->lang->Phrase['already_logged'] );

		//-----------------------------------------------------------
		// Let's verify some inputs
		//-----------------------------------------------------------

		// Username
		if( $this->class->Data("username") == null )
			$this->class->Error( $this->class->lang->Phrase['no_username'] );

		if( strlen( $this->class->Data("username") ) < 6 )
			$this->class->Error( $this->class->lang->Phrase['length_user'] );
		
		// Password
		if( $this->class->Data("password1") == null || $this->class->Data("password1") == null ) 
			$this->class->Error( $this->class->lang->Phrase['no_password'] );

		if( $this->class->Data("password1") != $this->class->Data("password2") )
			$this->class->Error( "passwords_nomatch");

		if( strlen( $this->class->Data("password1") ) < 6 || strlen( $this->class->Data("password2") ) < 6 )
			$this->class->Error( "pass_length" );

		// Email
		if( $this->class->Data("email") == null )
			$this->class->Error( "no_email");

		if( strpos( $this->class->Data("email"), "@" ) == false ) 
			$this->class->Error( "inv_email" );

		// First name
		if( $this->class->Data("fname") == null )
			$this->class->Error( "no_fname" );

		// Date of birth
		if( $this->class->Data("dobMonth") == null || $this->class->Data("dobDay") == null || $this->class->Data("dobYear") == null )
			$this->class->Error( "inv_dob" );

		// Gender
		if( $this->class->Data("gender") == null || ! in_array( $this->class->Data("gender"), array(1, 2) ) )
			$this->class->Error( "inv_gender" );

		// Country
		$Countries = functions::Countries();
		if( $this->class->Data("country") == null || ! in_array( $this->class->Data("country"), $Countries ) )
			$this->class->Error( "inv_country" );

		// Secret answer
		if( $this->class->Data("secret") == null)
			$this->class->Error( "secret_null" );

		/*if( ! in_array( stripslashes($this->class->Data("secret")), $this->class->lang->Phrase['secret_questions'] ) )
			$this->class->Error( "inv_secret" );*/

		if( $this->class->Data("secretanswer") == null )
			$this->class->Error( "no_secret" );

		// Did we select an avatar
		if( $this->class->Data("avatar") == null )
			$this->class->Error( "no_avatar" );

		// Is the avatar valid? i.e. we fetch them.
		$Avatars = functions::fetch_images("images/avatars");
		if( ! in_array( $this->class->Data("avatar"), $Avatars) )
			$this->class->Error( "inv_avatar" );

		// Recaptcha?
		if($this->class->Settings['force_captcha'] == '1')
		{
			$resp = $this->class->Recaptcha->recaptcha_check_answer ($this->class->Settings['privatekey'],
                               $_SERVER["REMOTE_ADDR"],
                               $this->class->Data("recaptcha_challenge_field"),
                               $this->class->Data("recaptcha_response_field"));

			 if (!$resp->is_valid)
				$this->class->Error( "inc_captcha" );
		}


		//-----------------------------------------------------------
		// Perform some queries
		//-----------------------------------------------------------

		// Is the username taken?
		$Query = "SELECT COUNT(*) FROM `users` WHERE `username` = '".$this->class->Data("username")."'";
		$Result = $this->class->mysql->Query($Query);
		$Amount = $this->class->mysql->FetchResults($Result);
		$Amount = $Amount[0]['COUNT(*)'];

		if ( intval($Amount) > 0 )
			$this->class->Error("taken_username");

		// Is the email taken?
		$Query = "SELECT COUNT(*) FROM `users` WHERE `email` = '".$this->class->Data("email")."'";
		$Result = $this->class->mysql->Query($Query);
		$Amount = $this->class->mysql->FetchResults($Result);
		$Amount = $Amount[0]['COUNT(*)'];

		if ( intval($Amount) > 0 )
			$this->class->Error("taken_email");

		//-----------------------------------------------------------
		// It all checks out. Let's add the user to the database
		//-----------------------------------------------------------

		$Query = "INSERT INTO `users` (`username`, `password`, `email`, `country`, `name`, `gender`, `secret_question`, `secret_answer`, `avatar`, `usergroup`, `join`, `public_email`, `msn`, `aim`, `skype`) VALUES(" .
			"'" . $this->class->Data("username")."', '".md5($this->class->Data("password1"))."', '".$this->class->Data("email")."', '".$this->class->Data("country")."', '".$this->class->Data("fname")."', '".$this->class->Data("gender")."', '".$this->class->Data("secret")."', '".$this->class->Data("secretanswer")."', 'images/avatars/".$this->class->Data("avatar")."', '1', '".time()."', '".$this->class->Data("public")."', '".$this->class->Data("msn")."', '".$this->class->Data("aim")."', '".$this->class->Data("skype")."')";

		$this->class->mysql->Query($Query);

		header("Location: ../login.html#registered");

	}

	//---------------------------------------------------------
    // Name:    submit_login()
    // Desc:    Log in to the user area.
    //---------------------------------------------------------

	function submit_login()
	{
		$this->return['path'] = "../";

		if( ! array_key_exists( 'remember', $_POST ) )
			$_POST['remember'] = 1;

		$Out = $this->class->Settings['users_login_by'] == '1' ? $this->class->lang->Phrase['log_email'] : ' ' . $this->class->lang->Phrase['usr_title'];

		if($this->class->Data("email") == null && $this->class->Data("username") == null)
			$this->class->Error( $this->class->lang->Phrase['must_entr'] . $Out . '.' );

		$Check = $this->class->Settings['users_login_by'] == '1' ? $this->class->lang->Phrase['email_title'] : $this->class->lang->Phrase['usr_title'];
		
		$res = functions::check_login($_POST[$Check], $_POST['password'], $_POST['remember']);
		
		if ($res['result'] == false)
		{
			$this->class->page['title'] = $this->class->lang->Phrase['log_error'];
			$this->class->Error($res['error']);
		}

		header("Location: ../user/");


		exit;
	
	}

	//---------------------------------------------------------
    // Name:    home()
    // Desc:    Main function called when user.php loads
    //---------------------------------------------------------

	function home()
	{
		//-----------------------------------------------------------
		// What to do if we are adding a wallpaper.
		//-----------------------------------------------------------

		if ($this->class->Data("action") == "submit") 
			return $this->SubmitWallpaper();

		$this->return['path'] = "../";
		$this->class->page['title'] = $this->class->lang->Phrase['usr_cp'] . " - ".$this->class->Settings['Site_Title'];

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		//-----------------------------------------------------------
		// Get the categories and subcategories
		//-----------------------------------------------------------

		$Query = "SELECT * FROM `categories`";
		$Res = $this->class->mysql->Query($Query);
		$Categories = $this->class->mysql->FetchResults($Res);

		$Structure = array();
		$Subs = array();
		foreach($Categories as $Cat) 
		{
			if ($Cat['parent'] == 0)
				$Structure[$Cat['id']] = array("name" => $Cat['name'], "Sub" => array());
			else $Subs[] = $Cat;
		}

		foreach($Subs as $Sub) 
			$Structure[$Sub['parent']]['Sub'][$Sub['id']] = $Sub['name'];

		asort($Structure);

		$Options = null;
		foreach($Structure as $id => $Cat)
		{
			$Options .= "<option value='".$id."'>".$Cat['name']."</option>\n";
			foreach($Cat['Sub'] as $sid => $scat)
				$Options .= "<option value='".$sid."'>&nbsp;&nbsp;&nbsp;- ".$scat."</option>\n";
		}

		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['user_wall_warning'],
		));

		//-----------------------------------------------------------
		// Lets output the user homepage
		//-----------------------------------------------------------

		$this->Output .= $this->class->template->LoadTemplate("login/user_home.cphp", array(
			"Options"		=> $Options,
			"min_length"	=> 3,
			"message"		=> $Message,
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;

	}

	function signup()
	{
		$this->return['path'] = "";
		$this->class->page['title'] = $this->class->lang->Phrase['sign_title'] . " - " . $this->class->Settings['Site_Title'];

		// Recaptcha
		if($this->class->Settings['force_captcha'] == '1')
			$recaptcha = $this->class->Recaptcha->recaptcha_get_html($this->class->Settings['publickey']);

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		// Message
		$Message = $this->class->template->LoadTemplate("global/error_custom.cphp", array(
			"message" => $this->class->lang->Phrase['signin_msg'],
			"width"	=> 400,
		));

		// Secret answers
		$Secret = null;
		foreach($this->class->lang->Phrase['secret_questions'] as $Question)
			$Secret .= '<option value="'.$Question.'">'.$Question.'</option>';
		
		$this->Output .= $this->class->template->LoadTemplate("login/signup.cphp", array(
			"message"	=> $Message,
			"countries"	=> functions::countries(true, 'United States'),
			"secret"	=> $Secret,
			'recaptcha'	=> isset($recaptcha) ? $recaptcha : null,
		));

		if (functions::check_logged() == true)
			header("Location: ".$this->return['path']."user/");

		return $this->Output;

	}

	function user_comment()
	{

		if (functions::check_logged() == false)
			die( $this->class->lang->Phrase['must_be_logged'] );

		if($this->class->Data("message") == null) 
			die( $this->class->lang->Phrase['no_message'] );

		if($this->class->Data("uid") == null)
			die( $this->class->lang->Phrase['inv_uid'] );

		if(!is_numeric($this->class->Data("uid")))
			die( $this->class->lang->Phrase['inv_uid'] );

		if(strlen($this->class->Data("message")) < $this->rep_min_length)
			die( str_replace('{x}', $this->rep_min_length, $this->class->lang->Phrase['msg_small']) );

		// Select last message left by user.
		$Query = "SELECT * FROM `user_comment` WHERE `uid`=".$this->class->User['userid']." ORDER BY `id` DESC LIMIT 1";
		$Result = $this->class->mysql->Query($Query);
		$lastMessage = $this->class->mysql->FetchResults($Result);
		
		// Flood control
		if (count($lastMessage) > 0)
		{
			if((time() - $lastMessage[0]['date']) < $this->wait_time)
				die( str_replace('{x}', $this->wait_time, $this->class->lang->Phrase['min_wait']) );
		}

		// If the user even exists
		$Query = "SELECT * FROM `users` WHERE `userid` = ".$this->class->Data("uid");
		$Result = $this->class->mysql->Query($Query);
		$tmpUser = $this->class->mysql->FetchResults($Result);
		
		if(count($tmpUser) == 0) 
			die($this->class->lang->Phrase['usrdphp_1']);

		$Message = $this->class->Data("message");
		$Message = strip_tags( $Message );


		$Query = "INSERT INTO `user_comment` (`rid`,`uid`,`message`,`date`) VALUES('".$this->class->Data("uid")."','".$this->class->User['userid']."','".$Message."','".time()."')";
		$Result = $this->class->mysql->Query($Query);

		exit;

		/*
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => 'Your message has been sent.',
		));

		$this->class->page['title'] = "User Control Panel - Your message has been sent.";

		$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=../../'.strtolower(str_replace(array(' '), '-', $tmpUser[0]['username'])).'.html"></HEAD>';

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		
		
		return $this->Output;
		*/

	}

	function view_user()
	{

		$this->return['path'] = "../";

		if($this->class->Data("user") == null)
			$this->class->Error("no_username");

		$Username = $this->class->Data("user");

		$this->class->page['title'] = $this->class->lang->Phrase['usr_view'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		$Query = "SELECT * FROM `users` WHERE `username`='".$Username."'";
		$Result = $this->class->mysql->Query($Query);
		$User = $this->class->mysql->FetchResults($Result);
		
		if(count($User) == 0)
			$this->class->Error("usr_noexist");

		//-------------------------------------------------------
		// Sort out wallpapers from user
		//-------------------------------------------------------

		$Query = "SELECT wallpapers.name, wallpapers.desc, wallpapers.votes, wallpapers.votecount, wallpapers.thumbSmall, wallpapers.id, categories.name as catName FROM `wallpapers` INNER JOIN categories on wallpapers.cat = categories.id WHERE `author`='".$this->class->Data('user')."' GROUP BY wallpapers.id ORDER BY RAND() LIMIT 3";
			
		$Res = $this->class->mysql->Query($Query);
		$sWallpapers = $this->class->mysql->FetchResults($Res);
		
		$similar = null;
		$extr = false;
		if (count($sWallpapers) == 0)
		{
			$similar = $User[0]['username'] . $this->class->lang->Phrase['no_uploads'];
			$extr = true;
		} else
		{
			foreach($sWallpapers as $Wall)
			{
				if( $Wall['votes'] > 0 ) {
					$Rating = floor( (int) $Wall['votecount'] / (int) $Wall['votes'] );
				} else $Rating = 0;

				$Star = null;
				for( $x = 1; $x <= 5; $x++ ) {
					$Num = ( $Rating < $x ) ? 2 : 1;
					$Star .= $this->class->template->LoadTemplate("home/homestar.cphp", array("img" => $Num));
				}			

				$Cat = $Wall['catName'];
				$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $Cat)));

				// Display a similar wallpaper
				$similar .= $this->class->template->LoadTemplate("login/user_wp.cphp", array(
						"title" => $Wall['name'],
						"alt" => $Wall['desc'],
						"name" => $CatUrl . "/" . utf8_encode(strtolower(str_replace(array(" "),'-', $Wall['name']))),
						"path" => $this->return["path"],
						"thumbnail" => $this->return["path"].$Wall['thumbSmall'],
						"wid" => $Wall['id'],
						"rating" => $Rating,
						"star" => $Star,
				));
			}
		}

		// Select the amount of wallpapers
		$Query = "SELECT COUNT(*) FROM `wallpapers` WHERE `author` = '".$User[0]['username']."'";
		$Result = $this->class->mysql->Query($Query);
		$Amount = $this->class->mysql->FetchResults($Result);
		$Uploads = $Amount[0]['COUNT(*)'];

		//-------------------------------------------------
		// Let's get the amount of messages for pag
		//-------------------------------------------------

		$Query = "SELECT COUNT(*) FROM `user_comment` WHERE `rid`='".$User[0]["userid"]."'";
		$Result = $this->class->mysql->Query($Query);
		$Amount = $this->class->mysql->FetchResults($Result);
		$Amount = $Amount[0]['COUNT(*)'];
		$Pages = ceil($Amount/$this->user_per_page);

		//-------------------------------------------------
		// Let's get started on the pagination!
		//-------------------------------------------------

		$Page = intval($this->class->Data("page"));
		$Page = ($Page == null) ? $Page = 1 : $Page;

		// Extra
		$filt = false;
		$Extra = ($Page > 1) ? $this->class->lang->Phrase['cat_ExtPage'] . $Page : null;
		$Start = ($Page * $this->WallpapersPerPage) - $this->WallpapersPerPage;
		$ext = ($filt == true) ? $this->class->Data("id") . "_" : null;

		$comHTML = $this->retrieve_user_comments(0,$this->user_per_page,$User[0]['userid'],$this->return['path']);

		$def = array(
			"user"		=> utf8_encode(strtolower(str_replace(array(' '), '-', $User[0]['username']))),
			"ugroup"	=> ($User[0]['usergroup'] == 1) ? $this->class->lang->Phrase['membrs_tit'] : $this->class->lang->Phrase['admin_tit'],
			"uext"		=> ($User[0]['usergroup'] == 1) ? null : '<span style="color: red; font-weight:bold;">',
			"uexte"		=> ($User[0]['usergroup'] == 1) ? null : '</span>',
			"join"		=> date("d M y", $User[0]['join']),
			"gender_c"	=> ($User[0]['gender'] == '1') ? '0000FF' : 'FF66CC',
			"uploads"	=> $Uploads,
			"gendert"	=> ($User[0]['gender'] == '1') ? $this->class->lang->Phrase['gen_male'] : $this->class->lang->Phrase['gen_female'],
		);

		//-----------------------------------------------------------
		// Contact information
		//-----------------------------------------------------------

		$contact = null;
		if($User[0]['public_email'] == 0 && $User[0]['msn'] == null && $User[0]['skype'] == null && $User[0]['aim'] == null)
			$cntHTML = null;
		else
		{
			$cntHTML = null;
			if($User[0]['public_email'] == 1)
				$cntHTML .= $this->class->template->LoadTemplate("login/contact/email.cphp", $User[0]);
			if($User[0]['msn'] != null)
				$cntHTML .= $this->class->template->LoadTemplate("login/contact/msn.cphp", $User[0]);
			if($User[0]['aim'] != null)
				$cntHTML .= $this->class->template->LoadTemplate("login/contact/aim.cphp", $User[0]);
			if($User[0]['skype'] != null)
				$cntHTML .= $this->class->template->LoadTemplate("login/contact/skype.cphp", $User[0]);
			
			$contact = $this->class->template->LoadTemplate("login/contact/contact.cphp", array("contact" => $cntHTML));
		}

		// Final array
		$arrUser = array(
			"similar"		=> $similar,
			"emots"			=> $this->Emoticons(),
			"comments"		=> $comHTML,
			"paghtml"		=> functions::pagHTML($Page,$Pages,$ext,"login/pag_","LoadComments"),
			"ext"			=> $ext,
			"pages"			=> $Pages,
			"extr"			=> ($extr == true) ? "style='height: auto;'" : null,
		);

		// Fix up some user details
		$User[0]['about'] = ($User[0]['about'] == null) ? $this->class->lang->Phrase['usr_noset'] : $User[0]['about'];

		$this->Output .= $this->class->template->LoadTemplate("login/user.cphp", array_merge($arrUser, $User[0], $def));

		$comHTML = null;

		$this->Output .= $this->class->template->LoadTemplate("login/user_profile_right.cphp", array_merge($this->class->Settings, array(
			"comments"		=> $comHTML,
			"contact"		=> $contact,
			"username"		=> utf8_encode(strtolower(str_replace(array(' '), '-', $User[0]['username']))),
		)));


		
		return $this->Output;		

	}

	function retrieve_user_comments($start=0,$end=5,$user=1,$path="")
	{
		$Query = "SELECT * FROM `user_comment` WHERE `rid` = ".$user." ORDER BY `id` DESC LIMIT ".$start.",".$end;
		$Result = $this->class->mysql->Query($Query);
		$Comments = $this->class->mysql->FetchResults($Result);

		$comHTML = null;

		if(count($Comments) == 0) 
			$comHTML = $this->class->lang->Phrase['no_comments'];

		foreach($Comments as $Comment)
		{
			// Select the user
			$cQuery = "SELECT * FROM `users` WHERE `userid`=".$Comment['uid'];
			$cResult = $this->class->mysql->Query($cQuery);
			$cUser = $this->class->mysql->FetchResults($cResult);
			$cUser = $cUser[0];

			$comHTML .= $this->class->template->LoadTemplate("login/user_comment.cphp", array_merge($cUser,array(
				"f_message"		=> str_replace('<br />', ' ', functions::format_message($Comment['message'],false,$path)),
				"user"			=> utf8_encode(strtolower(str_replace(array(' '), '-', $cUser['username']))),
				"time"			=> date("d M Y - H:i", $Comment['date']),
				"path"			=> $path,
			)));
		}

		return $comHTML;

	}

	//---------------------------------------------------------
    // Name:    show_message()
    // Desc:    Show the private message from the inbox.
    //---------------------------------------------------------

	function show_message()
	{
		$this->return['path'] = "../../../";

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		$Query = "SELECT * FROM `messages` WHERE `id` = ".$this->class->Data("mid");
		$Result = $this->class->mysql->Query($Query);
		$Message = $this->class->mysql->FetchResults($Result);

		if(count($Message) == 0)
			$this->class->Error( "msg_nofound" );

		if($Message[0]['to'] != $this->class->User['userid'])
			$this->class->Error( 'msg_noperms' );

		
		//---------------------------------------
		// Let's format the message
		//---------------------------------------

		$emot = $this->Emoticons();

		$msg = functions::format_message($Message[0]['message']);
		$msg = str_replace("href=\"../", "href=\"../../../", $msg);

		// Remove the curse words
		$msg = functions::RemoveCurseWords($msg,$this->class->Settings['curse_words']);

		// Let's retrieve the user
		$Query = "SELECT * FROM `users` WHERE `userid` = ".$Message[0]['from'];
		$Result = $this->class->mysql->Query($Query);
		$User = $this->class->mysql->FetchResults($Result);

		// If the user exists
		if (count($User) > 0)
		{
			// Select the amount of wallpapers
			$Query = "SELECT COUNT(*) FROM `wallpapers` WHERE `author` = '".$User[0]['username']."'";
			$Result = $this->class->mysql->Query($Query);
			$Amount = $this->class->mysql->FetchResults($Result);
			$Uploads = $Amount[0]['COUNT(*)'];

			$def = array(
				"user"		=> utf8_encode(strtolower(str_replace(array(' '), '-', $User[0]['username']))),
				"ugroup"	=> ($User[0]['usergroup'] == 1) ? $this->class->lang->Phrase['membrs_tit'] : $this->class->lang->Phrase['admin_tit'],
				"uext"		=> ($User[0]['usergroup'] == 1) ? null : '<span style="color: red; font-weight:bold;">',
				"uexte"		=> ($User[0]['usergroup'] == 1) ? null : '</span>',
				"join"		=> date("d M y", $User[0]['join']),
				"gender_c"	=> ($User[0]['gender'] == '1') ? '0000FF' : 'FF66CC',
				"uploads"	=> $Uploads,
				"gendert"	=> ($User[0]['gender'] == '1') ? $this->class->lang->Phrase['gen_male'] : $this->class->lang->Phrase['gen_female'],
				"message"	=> $msg,
				"message_s"	=> date("d F Y - h:i A", $Message[0]['time']),
			);
		} else
		{
			$User[0] = array("userid" => -1, "username" => $this->class->lang->Phrase['auto_bot_name'], "avatar" => "images/avatars/no-avatar.jpg");
			$def = array(
				"user"		=> strtolower($this->class->lang->Phrase['auto_ugroup']),
				"ugroup"	=> $this->class->lang->Phrase['auto_ugroup'],
				"uext"		=> '<i>',
				"uexte"		=> '</i>',
				"join"		=> date("d M y", 0),
				"gender_c"	=> '000000',
				"uploads"	=> '0',
				"gendert"	=> $this->class->lang->Phrase['none'],
				"message"	=> $msg,
				"message_s"	=> date("d F Y - h:i A", $Message[0]['time']),
				"disabled"	=> ' ' .  $this->class->lang->Phrase['disabled'],
			);
		}

		// Global array
		$glob = array(
			"emots"		=> $emot,
			"mid"		=> $Message[0]['id'],
		);

		$output = array_merge($User[0],$def,$glob);
		
		$this->Output .= $this->class->template->LoadTemplate("login/message.cphp", $output);

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $this->Comments(5, $this->return['path']),
		));

		// Mark it as read
		$Query = "UPDATE `messages` SET `read` = 1 WHERE `id` = ".$Message[0]['id'];
		$Result = $this->class->mysql->Query($Query);

		// Title
		$this->class->page['title'] = $this->class->lang->Phrase['view_msg'] . " - ".$Message[0]['title'];
		
		
		return $this->Output;

	}

	//---------------------------------------------------------
    // Name:    reply_message()
    // Desc:    Processes the replied, posted message.
    //---------------------------------------------------------

	function reply_message()
	{

		$this->return['path'] = "../../../";

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		if($this->class->Data("message") == null) 
			$this->class->Error("no_message");

		if($this->class->Data("mid") == null)
			$this->class->Error("inv_id");

		if(!is_numeric($this->class->Data("mid")))
			$this->class->Error("inv_id");

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		$Query = "SELECT * FROM `messages` WHERE `id` = ".$this->class->Data("mid");
		$Result = $this->class->mysql->Query($Query);
		$Message = $this->class->mysql->FetchResults($Result);

		if(strpos(strtolower($Message[0]['title']),'re:') == 0)
			$Title = 'Re: '.$Message[0]['title'];
		else $Title = $Message[0]['title'];

		if(count($Message) == 0)
			$this->class->Error("msg_nofound");

		if($Message[0]['from'] == $this->class->User['userid'])
			$this->class->Error("msg_noself");

		if(in_array($Message[0]['from'], array(0,-1)))
			$this->class->Error("msg_noperms");

		if(strlen($this->class->Data("message")) < $this->rep_min_length)
			$this->class->Error( str_replace('{x}', $this->rep_min_length, $this->class->lang->Phrase['msg_small']) );

		// Select last message left by user.
		$Query = "SELECT * FROM `messages` WHERE `from`=".$this->class->User['userid']." ORDER BY `id` DESC LIMIT 1";
		$Result = $this->class->mysql->Query($Query);
		$lastMessage = $this->class->mysql->FetchResults($Result);
		
		// Flood control
		if (count($lastMessage) > 0)
		{
			if((time() - $lastMessage[0]['time']) < $this->wait_time)
				$this->class->Error( str_replace('{x}', $this->wait_time, $this->class->lang->Phrase['min_wait']) );
		}

		// If the user even exists
		$Query = "SELECT * FROM `users` WHERE `userid` = ".$Message[0]['from'];
		$Result = $this->class->mysql->Query($Query);
		$tmpUser = $this->class->mysql->FetchResults($Result);
		
		if(count($tmpUser) == 0) 
			$this->class->Error($this->class->lang->Phrase['usrdphp_1']);


		$Query = "INSERT INTO `messages` (`to`,`from`,`title`,`message`,`time`) VALUES('".$Message[0]['from']."','".$this->class->User['userid']."','".$Title."','".$this->class->Data("message")."','".time()."')";
		$Result = $this->class->mysql->Query($Query);

		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['msg_sent'],
		));

		$this->class->page['title'] = $this->class->lang->Phrase['msg_sent_title'];

		$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=../../inbox.html"></HEAD>';

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		
		
		return $this->Output;

	}

	//---------------------------------------------------------
    // Name:    new_message()
    // Desc:    Handles the composition of a new message.
    //---------------------------------------------------------

	function new_message()
	{
		
		$this->return['path'] = "../";

		$URI = $_SERVER['REQUEST_URI'];
		preg_match_all('/recipient\=(\w+)/', $URI, $Res);
		
		if(isset($Res[1][0]))
			$Recipient = addslashes($Res[1][0]);
		else $Recipient = null;

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		// Just declare some variables (PHP likes throwing out error messages if we don't).
		$msgHTML = null;
		$Page = null;
		$Pages = null;
		$ext = null;
		$Message = null;

		if(isset($_POST['recipient']))
		{
			if($this->class->Data("recipient") == null)
				$this->class->Error("choose_mbr");

			if($this->class->Data("message") == null)
				$this->class->Error("no_message");

			if($this->class->Data("title") == null)
				$this->class->Error("no_msg_title");

			if(strlen($this->class->Data("message")) < $this->rep_min_length)
				$this->class->Error( str_replace('{x}', $this->rep_min_length, $this->class->lang->Phrase['msg_small']) );

			if(strtolower($this->class->Data("recipient")) == strtolower($this->class->User['username']))
				$this->class->Error( "msg_noself" );
		
			// Select last message left by user.
			$Query = "SELECT * FROM `messages` WHERE `from`=".$this->class->User['userid']." ORDER BY `id` DESC LIMIT 1";
			$Result = $this->class->mysql->Query($Query);
			$lastMessage = $this->class->mysql->FetchResults($Result);
			
			// Flood control
			if (count($lastMessage) > 0)
			{
				if((time() - $lastMessage[0]['time']) < $this->wait_time)
					$this->class->Error( str_replace('{x}', $this->wait_time, $this->class->lang->Phrase['min_wait']) );
			}

			// If the user even exists
			$Query = "SELECT * FROM `users` WHERE `username` = '".$this->class->Data("recipient")."'";
			$Result = $this->class->mysql->Query($Query);
			$tmpUser = $this->class->mysql->FetchResults($Result);
			
			if(count($tmpUser) == 0) 
				$this->class->Error($this->class->lang->Phrase['usrdphp_1']);

			//-------------------------------------------------------
			// Send the message
			//-------------------------------------------------------

			$Query = "INSERT INTO `messages` (`to`,`from`,`title`,`message`,`time`) VALUES('".$tmpUser[0]['userid']."','".$this->class->User['userid']."','".$this->class->Data("title")."','".$this->class->Data("message")."','".time()."')";
			$Result = $this->class->mysql->Query($Query);

			$comHTML = $this->Comments(5, $this->return['path']);

			// Get the message
			$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
				"message" => $this->class->lang->Phrase['msg_sent'],
			));

			$this->class->page['title'] = $this->class->lang->Phrase['msg_sent_title'];


			$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=inbox.html"></HEAD>';

			$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
				"comments"		=> $comHTML,
			));

			
			
			return $this->Output;
		
		}

		$this->Output .= $this->class->template->LoadTemplate("login/new_message.cphp", array(
			"messages"		=> $msgHTML,
			"paghtml"		=> functions::pagHTML($Page,$Pages,$ext,"login/pag_","LoadMessages"),
			"pages"			=> $Pages,
			"ext"			=> $ext,
			"message"		=> $Message,
			"emot"			=> $this->Emoticons(),
			"recipient"		=> $Recipient,
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $this->Comments(5, $this->return['path']),
		));

		$this->class->page['title'] = $this->class->lang->Phrase['usr_compose'];
		
		
		return $this->Output;


	}

	//---------------------------------------------------------
    // Name:    inbox()
    // Desc:    Output and coordinate functions of the user inbox.
    //---------------------------------------------------------

	function inbox()
	{
		
		$this->return['path'] = "../";

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		//-----------------------------------------------------------
		// Are we deleting/marking as (un)read messages?
		//-----------------------------------------------------------

		if($this->class->Data('mass') != null)
		{
			//-----------------------------------
			// Mass delete messages
			//-----------------------------------

			if($this->class->Data('mass') == 'delete')
			{
				foreach($_POST['Message'] as $id)
				{
					if($id != null)
					{
						$id = addslashes($id);
						
						$Query = "SELECT * FROM `messages` WHERE `id`=".$id;
						$Result = $this->class->mysql->Query($Query);
						$Message = $this->class->mysql->FetchResults($Result);
						$Message=$Message[0];

						// If we are the author, lets delete it.
						if ($Message['to'] == $this->class->User["userid"])
							$this->class->mysql->Query("DELETE FROM `messages` WHERE `id`=".$id);

						$Message = $this->class->lang->Phrase['usr_msg_del'];
					}
				}
			
			//-----------------------------------
			// Mark messages as read
			//-----------------------------------

			} elseif($this->class->Data("mass") == 'read')
			{
				foreach($_POST['Message'] as $id)
				{
					if($id != null)
					{
						$id = addslashes($id);
						
						$Query = "SELECT * FROM `messages` WHERE `id`=".$id;
						$Result = $this->class->mysql->Query($Query);
						$Message = $this->class->mysql->FetchResults($Result);
						$Message=$Message[0];

						// If we are the author, lets delete it.
						if ($Message['to'] == $this->class->User["userid"])
							$this->class->mysql->Query("UPDATE `messages` SET `read`=1 WHERE `id`=".$id);

						header("Location: inbox.html");
					}
				} 

			//-----------------------------------
			// Mark messages as unread
			//-----------------------------------

			} elseif($this->class->Data("mass") == 'unread')
			{
				foreach($_POST['Message'] as $id)
				{
					if($id != null)
					{
						$id = addslashes($id);
						
						$Query = "SELECT * FROM `messages` WHERE `id`=".$id;
						$Result = $this->class->mysql->Query($Query);
						$Message = $this->class->mysql->FetchResults($Result);
						$Message=$Message[0];

						// If we are the author, lets delete it.
						if ($Message['to'] == $this->class->User["userid"])
							$this->class->mysql->Query("UPDATE `messages` SET `read`=0 WHERE `id`=".$id);

						header("Location: inbox.html");
					}
				}
			}

			$comHTML = $this->Comments(5, $this->return['path']);

			// Get the message
			$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
				"message" => $Message,
			));

			$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=inbox.html"></HEAD>';

			$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
				"comments"		=> $comHTML,
			));

			$this->class->page['title'] = $this->class->lang->Phrase['del_msgs'] . " - ".$this->class->Settings['Site_Title'];

			
			return $this->Output;

		}

		//-------------------------------------------------
		// Let's get the amount of messages for pag
		//-------------------------------------------------

		$Query = "SELECT COUNT(*) FROM `messages` WHERE `to`='".$this->class->User["userid"]."'";
		$Result = $this->class->mysql->Query($Query);
		$Amount = $this->class->mysql->FetchResults($Result);
		$Amount = $Amount[0]['COUNT(*)'];
		$Pages = ceil($Amount/$this->per_page);

		//-------------------------------------------------
		// Let's get started on the pagination!
		//-------------------------------------------------

		$Page = intval($this->class->Data("page"));
		$Page = ($Page == null) ? $Page = 1 : $Page;

		// Extra
		$filt = false;
		$Extra = ($Page > 1) ? $this->class->lang->Phrase['cat_ExtPage'] . $Page : null;
		$Start = ($Page * $this->WallpapersPerPage) - $this->WallpapersPerPage;
		$ext = ($filt == true) ? $this->class->Data("id") . "_" : null;

		$msgHTML = $this->retrieve_messages(0,$this->per_page);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['compose_new'],
		));
		
		$this->Output .= $this->class->template->LoadTemplate("login/inbox.cphp", array(
			"messages"		=> $msgHTML,
			"paghtml"		=> functions::pagHTML($Page,$Pages,$ext,"login/pag_","LoadMessages"),
			"pages"			=> $Pages,
			"ext"			=> $ext,
			"message"		=> $Message,
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $this->Comments(5, $this->return['path']),
		));

		$this->class->page['title'] = $this->class->lang->Phrase['usr_view_msg'];
		
		
		return $this->Output;


	}

	//---------------------------------------------------------
    // Name:    retrieve_messages(Start, End)
    // Desc:    Retrieve messages from the database.
    //---------------------------------------------------------

	function retrieve_messages($Start=0,$End=10)
	{
		$Query = "SELECT * FROM `messages` WHERE `to`=".$this->class->User['userid']." ORDER BY `id` DESC LIMIT ".$Start.",".$End;
		$Result = $this->class->mysql->Query($Query);
		$Messages = $this->class->mysql->FetchResults($Result);

		$Users = array();

		$msgHTML = null;
		foreach($Messages as $Message)
		{
			if (!in_array($Message['from'],$Users))
			{
				$Query = "SELECT * FROM `users` WHERE `userid`=".$Message['from'];
				$Result = $this->class->mysql->Query($Query);
				$User = $this->class->mysql->FetchResults($Result);
				if (count($User) == 0) //bot
					$User = array('userid' => $Message['from'], 'username' => $this->class->lang->Phrase['auto_ugroup']);
				else $User = $User[0];
				$Users[$User['userid']] = $User;
			}

			$msgHTML .= $this->class->template->LoadTemplate("login/inbox_message.cphp", array(
					"name"		=> $Message['title'],
					"date"		=> date("d M Y", $Message['time']),
					"from"		=> $Users[$Message['from']]['username'],
					"id"		=> $Message['id'],
					"path"		=> "../",
					"ext_start"	=> $Message['read'] == 0 ? "<span style='font-weight:bold; text-decoration: none;'>" : null,
					"ext_end"	=> $Message['read'] == 0 ? '</span>' : null,
					"user"		=> utf8_encode(strtolower(str_replace(array(' '), '-', $Users[$Message['from']]['username']))),
			));
		}
		return $msgHTML;
	}

	function show_comments()
	{
		die($this->retrieve_user_comments($this->user_per_page*($this->class->Data("page")-1),$this->user_per_page, $this->class->Data("uid"), "../"));
	}

	//---------------------------------------------------------
    // Name:    show_messages()
    // Desc:    Output messages from database (FOR AJAX)
    //---------------------------------------------------------

	function show_messages()
	{
		die($this->retrieve_messages($this->per_page*($this->class->Data("page")-1),$this->per_page));
	}

	//---------------------------------------------------------
    // Name:    show_walls()
    // Desc:    Output wallpapers from database (FOR AJAX)
    //---------------------------------------------------------

	function show_walls()
	{
		die($this->fetch_wallpapers($this->per_page*($this->class->Data("wallid")-1),$this->per_page));
	}

	//---------------------------------------------------------
    // Name:    mass_delete()
    // Desc:    Process mass delete (1 of 2)
    //---------------------------------------------------------

	function mass_delete()
	{
		if (array_key_exists('Wallpaper', $_REQUEST) == false || count($_REQUEST['Wallpaper']) == 0)
			$this->class->Error("min_1_wp");
		
		$Delete = array();
		foreach($_REQUEST['Wallpaper'] as $id)
			$Delete[] = addslashes($id);
		
		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = $this->class->lang->Phrase['usr_delt_msgs'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
	
		
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['usr_final_chan'],
		));
		
		$dhtml = null;
		foreach($Delete as $id)
			$dhtml .= $id."|";


		$this->Output .= $this->class->template->LoadTemplate("login/mass_delete_confirmation.cphp", array(
			"wallpapers"	=> $dhtml,
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;
	}

	//---------------------------------------------------------
    // Name:    do_mass_delete()
    // Desc:    Process mass delete (2 from 2)
    //---------------------------------------------------------

	function do_mass_delete()
	{
		if ($this->class->Data("wallpapers") == null)
			$this->Error("min_1_wp");

		$Wallpapers = explode("|",$this->class->Data("wallpapers"));
		
		foreach($Wallpapers as $id)
		{
			if ($id != null)
			{
				$Query = "SELECT * FROM `wallpapers` WHERE `id`=".$id;
				$Result = $this->class->mysql->Query($Query);
				$Wallpaper = $this->class->mysql->FetchResults($Result);
				$Wallpaper=$Wallpaper[0];

				// If we are the author, lets delete it.
				if ($Wallpaper['author'] == $this->class->User["username"])
					$this->delete_wallpaper($Wallpaper,false);
			}
		}

		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = $this->class->lang->Phrase['usr_mass_del'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
	
		
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['wp_deleted'],
		));

		$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=gallery.html"></HEAD>';

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;

	}

	//---------------------------------------------------------
    // Name:    pag()
    // Desc:    Output pagination (FOR AJAX).
    //---------------------------------------------------------

	function pag()
	{
		die(functions::pagHTML($this->class->Data("page"), $this->class->Data("pages"), $this->class->Data("ext"),"login/pag_",$this->class->Data("onclick")));
	}

	//---------------------------------------------------------
    // Name:    gallery()
    // Desc:    Output the wallpaper gallery.
    //---------------------------------------------------------

	function gallery()
	{
		$this->return['path'] = "../";

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		if ($this->class->Data("action") == "submit")
			return $this->mass_delete();

		if ($this->class->Data("action") == "submit_delete")
			return $this->do_mass_delete();

		$Query = "SELECT COUNT(*) FROM `wallpapers` WHERE `author`='".$this->class->User["username"]."'";
		$Result = $this->class->mysql->Query($Query);
		$Amount = $this->class->mysql->FetchResults($Result);
		$Amount = $Amount[0]['COUNT(*)'];
		$Pages = ceil($Amount/$this->per_page);

		//-------------------------------------------------
		// Let's get started on the pagination!
		//-------------------------------------------------

		$Page = intval($this->class->Data("page"));
		$Page = ($Page == null) ? $Page = 1 : $Page;

		// Extra
		$filt = false;
		$Extra = ($Page > 1) ? $this->class->lang->Phrase['cat_ExtPage'] . $Page : null;
		$Start = ($Page * $this->WallpapersPerPage) - $this->WallpapersPerPage;
		$ext = ($filt == true) ? $this->class->Data("id") . "_" : null;

		// If we are viewing all
		if ($this->class->Data("mode") == "all")
			$Pages = 1;

		$paghtml = functions::pagHTML($Page,$Pages,$ext);		
		
		//-----------------------------------------------------------
		// Let's fetch the wallpapers
		//-----------------------------------------------------------

		$wallHTML = $this->fetch_wallpapers(0,$this->per_page);
		
		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = $this->class->lang->Phrase['manage_wp'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
	
		
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['changes_nound'],
		));


		$this->Output .= $this->class->template->LoadTemplate("login/gallery.cphp", array(
			"wallpapers"	=> $wallHTML,
			"paghtml"		=> $paghtml,
			"page"			=> $Page,
			"pages"			=> $Pages,
			"ext"			=> $ext,
			"message"		=> $Message,
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;

	}

	//---------------------------------------------------------
    // Name:    fetch_wallpapers(Start,End)
    // Desc:    Fetch the wallpapers from the database.
    //---------------------------------------------------------

	function fetch_wallpapers($start=0,$end=10)
	{
		$Query = "SELECT wallpapers.id, wallpapers.name, categories.name as `cat` FROM `wallpapers` INNER JOIN categories on wallpapers.cat = categories.id WHERE `author`='".$this->class->User['username']."' GROUP BY wallpapers.id ORDER BY wallpapers.id DESC LIMIT ".$start.",".$end;
		$Result = $this->class->mysql->Query($Query);
		$Wallpapers = $this->class->mysql->FetchResults($Result);

		$wallHTML = null;
		foreach($Wallpapers as $Wallpaper) 
		{
			$wallHTML .= $this->class->template->LoadTemplate("login/gallery_wall.cphp", array(
				"id"		=> $Wallpaper['id'],
				"name"		=> $Wallpaper['name'],
				"cat"		=> $Wallpaper['cat'],
			));
		}
		return $wallHTML;
	}

	//---------------------------------------------------------
    // Name:    delete_wallpaper()
    // Desc:    Process the deletion of a wallpaper.
    //---------------------------------------------------------

	function delete_wallpaper($Wallpaper,$Output = true)
	{
		// Remove from the wallpapers table
		$Query = "DELETE FROM `wallpapers` WHERE `id`=".$Wallpaper['id'];
		$this->class->mysql->Query($Query);

		// Do we need to remove the images?
		if($this->class->Data("delete_images") == "on")
		{
			// Remove the thumbnails
			if (file_exists($Wallpaper['thumbSmall']))
				unlink($Wallpaper['thumbSmall']);
			if (file_exists($Wallpaper['thumbLarge']))
				unlink($Wallpaper['thumbLarge']);

			$Query = "SELECT * FROM `wallpaper_uploads` WHERE `wid`=".$Wallpaper['id'];
			$Result = $this->class->mysql->Query($Query);
			$Uploads = $this->class->mysql->FetchResults($Result);

			foreach($Uploads as $Upload)
			{
				if(file_exists($Upload['url']))
					unlink($Upload['url']);			
			}
		}

		// Delete the rows in the upload table
		$Query = "DELETE * FROM `wallpaper_uploads` WHERE `wid`=".$Wallpaper['id'];

		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		if ($Output == true)
		{

			$this->class->page['title'] = "User Control Panel - Delete Wallpaper - ".$this->class->Settings['Site_Title'];

			// Categories
			$this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
			$this->Output .= $this->class->CompileCategories();
			$this->Output .= $this->class->CompilePartners();
			$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
		
			
			$comHTML = $this->Comments(5, $this->return['path']);

			// Get the message
			$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
				"message" => $this->class->lang->Phrase['changes_nound'],
			));

			$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=../../../gallery.html"></HEAD>';

			$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
				"comments"		=> $comHTML,
			));

			

			return $this->Output;
		}

	}

	//---------------------------------------------------------
    // Name:    delete()
    // Desc:    Delete a wallpaper from the database (output).
    //---------------------------------------------------------

	function delete()
	{

		$this->return['path'] = "../../../../";

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		if ($this->class->Data("wallid") == null || !is_numeric($this->class->Data("wallid")))
			$this->class->Error("inv_wid");

		$Query = "SELECT wallpapers.id, wallpapers.name as `wallpaper`, wallpapers.thumbSmall, wallpapers.thumbLarge, wallpapers.views, wallpapers.votes, wallpapers.votecount, wallpapers.time, wallpapers.author, wallpapers.downloads, wallpapers.comments, categories.name as `category` FROM `wallpapers` INNER JOIN categories ON wallpapers.cat = categories.id WHERE wallpapers.id=".$this->class->Data("wallid")." GROUP BY wallpapers.id";
		$Result = $this->class->mysql->Query($Query);
		$Wallpaper = $this->class->mysql->FetchResults($Result);
		$Wallpaper = $Wallpaper[0];

		if (count($Wallpaper) == 0)
			$this->class->Error("wallpaper_noexist");

		if ($Wallpaper['author'] != $this->class->User['username'])
			$this->class->Error("no_perm_del");

		if ($this->class->Data("action") == "submit")
			return $this->delete_wallpaper($Wallpaper);

		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = $this->class->lang->Phrase['usr_ctrl_del1'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
	
		
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['usr_final_chan'],
		));

		$userRating = (intval($Wallpaper['votecount']) == 0) ? 0 : round(intval($Wallpaper['votecount']) / intval($Wallpaper['votes']),1);

		$this->Output .= $this->class->template->LoadTemplate("login/delete.cphp", array(
			"wallpaper_name"	=> $Wallpaper['wallpaper'],
			"category"			=> $Wallpaper['category'],
			"submitted"			=> date("d M Y", $Wallpaper['time']),
			"views"				=> number_format($Wallpaper['views']),
			"rating"			=> $userRating,
			"downloads"			=> number_format($Wallpaper['downloads']),
			"comments"			=> number_format($Wallpaper['comments']),
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;



	}

	//---------------------------------------------------------
    // Name:    change_pass()
    // Desc:    Process the change pass.
    //---------------------------------------------------------

	function change_pass()
	{

		$this->return['path'] = "../";

		if ($this->class->Data("old_password") == null)
			$this->class->Error("no_cur_pw");

		if ($this->class->Data("new_password1") == null || $this->class->Data("new_password2") == null)
			$this->class->Error("entr_new_pw");

		if ($this->class->Data("new_password1") != $this->class->Data("new_password2"))
			$this->class->Error("pw_nomatch");

		if (strlen($this->class->Data("new_password1")) < $this->min_length)
			$this->class->Error("Your password can not be under ".$this->min_length." characters.");

		if (md5($this->class->Data("old_password")) != $this->class->User['password'])
			$this->class->Error("Your old password is invalid.");

		$Query = "UPDATE `users` SET `password`='".md5($this->class->Data("new_password1"))."' WHERE `userid`=".$this->class->User['userid'];
		$this->class->mysql->Query($Query);

		// Update the cookie
		setcookie('password', md5($this->class->Data("new_password1")), time()+604800, "/");

		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = "User Control Panel - Changed Password - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
	
		
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => 'Your password has been updated.',
		));

		$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=edit.html"></HEAD>';

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;

	}

	//---------------------------------------------------------
    // Name:    edit_account_submit()
    // Desc:    Actually edit the account settings (mysql).
    //---------------------------------------------------------

	function edit_account_submit()
	{
		
		$this->return['path'] = "../";

		//-----------------------------------------------------------
		// Lets perform some checks prior to continuing
		//-----------------------------------------------------------

		// Are we logged in?
		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		// Did we enter an old password?
		if ($this->class->Data("hidden_password") == null)
			$this->class->Error("no_cur_pw");

		// Is our old password incorrect?
		if (md5($this->class->Data("hidden_password")) != $this->class->User['password'])
			$this->class->Error("old_pw_inv");

		// Have we entered a null email?
		if ($this->class->Data("email") == null)
			$this->class->Error("no_email");

		// Is the email valid?
		if (strpos($this->class->Data("email"),"@") == 0)
			$this->class->Error("inv_email");

		// Have we entered a null name?
		if ($this->class->Data("name") == null)
			$this->class->Error("no_name");

		// Have we selected a country?
		if ($this->class->Data("country") == null)
			$this->class->Error("inv_country");

		// Is the country even valid?
		if (!in_array($this->class->Data("country"), functions::Countries()))
			$this->class->Error("inv_country");

		// Have we selected a gender?
		if ($this->class->Data("gender") == null)
			$this->class->Error("You must select a gender.");

		// Is the gender even valid?
		if (!in_array($this->class->Data("gender"), array(1,2)))
			$this->class->Error("inv_gender");

		// Are we updating the secret question, if so, is it null?
		if ((stripslashes($this->class->Data("secret_question")) != $this->class->User['secret_question']) && $this->class->Data("secret_answer") == null) 
			$this->class->Error("no_secret");

		// Is the secret question even valid?
		if (!in_array(stripslashes($this->class->Data("secret_question")), $this->class->lang->Phrase['secret_questions']))
			$this->class->Error("inv_secret");

		$About = addslashes(strip_tags($this->class->Data("about")));

		//-----------------------------------------------------------
		// Lets perform the update queries
		//-----------------------------------------------------------

		$Secret = ($this->class->Data("secret_answer") != null) ? $this->class->Data("secret_answer") : $this->class->User['secret_answer'];

		$Query = "UPDATE `users` SET `email`='".$this->class->Data("email")."', `country`='".$this->class->Data("country")."', `name`='".$this->class->Data("name")."', `gender`=" . $this->class->Data("gender") . ", `secret_question`='".$this->class->Data("secret_question")."', `secret_answer`='".$Secret."', `about` = '" . $About . "' WHERE `userid`=" . $this->class->User['userid'];
		$Res = $this->class->mysql->Query($Query);

		// Update email
		setcookie('username', $this->class->Data("email"), time()+604800, "/");

		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = $this->class->lang->Phrase['usrcp_update'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
	
		
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['msg_updated'],
		));

		$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div><meta http-equiv="REFRESH" content="3;url=edit.html"></HEAD>';

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;
	}

	//---------------------------------------------------------
    // Name:    submit_edit_wallpaper()
    // Desc:    What to do when we've submitted the edited wallpaper.
    //---------------------------------------------------------

	function submit_edit_wallpaper()
	{

		//-----------------------------------------------------------
		// Lets just filter out the content
		//-----------------------------------------------------------

		$Posted = array();
		foreach($_REQUEST as $ide => $val)
			$Posted[$ide] = str_replace(array("'"), null, $this->class->Data($ide));

		$Dim = array();
		if (array_key_exists('Dimensions', $_REQUEST) && count($_REQUEST['Dimensions']) > 0) 
		{
			foreach($_REQUEST['Dimensions'] as $i => $v)
				$Dim[addslashes($i)] = addslashes($v);
		}

		$Posted['Dimensions'] = $Dim;

		//-----------------------------------------------------------
		// Perform some basic check
		//-----------------------------------------------------------

		if (!is_numeric($this->class->Data("wallid")))
			$this->class->Error("Wallpaper id is not valid.");

		$Query = "SELECT * FROM `wallpapers` WHERE `id`='".$this->class->Data("wallid")."'";
		$Result = $this->class->mysql->Query($Query);
		$Wallpaper = $this->class->mysql->FetchResults($Result);
		$Wallpaper = $Wallpaper[0];

		if (count($Wallpaper) == 0)
			$this->class->Error("wallpaper_noexist");

		if ($Wallpaper['author'] != $this->class->User['username'])
			$this->class->Error("perm_noedit_wall");
		
		//-----------------------------------------------------------
		// Lets upload it!
		//-----------------------------------------------------------

		if ($Posted['title'] == null)
			$this->class->Error("no_wtitle");

		if ($Posted['tags'] == null)
			$this->class->Error("no_wtags");

		if ($Posted['description'] == null)
			$this->class->Error("no_wdesc");

		if ($Posted['cat'] == null || !is_numeric($Posted['cat']))
			$this->class->Error("inv_cid");


		//-----------------------------------------------------------
		// Upload the thumbnails (large and small)
		//-----------------------------------------------------------

		if ($this->class->Data("wallpaper") != null)
		{

			$Wallpaper['name'] = preg_replace("/([ ]+)/","_",strtolower($Posted['title']));
			$Wallpaper['extension'] = substr($Posted['path'], strrpos($Posted['path'],'.'));
			$Wallpaper['file'] = "thumbnails/";
			$Posted['path'] = str_replace("../../", null,$Posted['path']);
			list($Wallpaper['width'],$Wallpaper['height']) = getimagesize($Posted['path']);

			$resizeRatio = $Wallpaper['width'] / 488;
			$Width = 488;
			$Height = round($Wallpaper['height'] / $resizeRatio,0);

			// Large thumbnail
			$ThumbLarge = $Wallpaper['file']."large_".$Wallpaper['name']."_".rand(1,100000).$Wallpaper['extension'];
			functions::resizeImage($Posted['path'],$ThumbLarge,$Width,$Height);

			// Small thumbnail
			$ThumbSmall = $Wallpaper['file'].$Wallpaper['name']."_".rand(10000,100000).$Wallpaper['extension'];
			functions::resizeImage($Posted['path'],$ThumbSmall,160,120); // Revision: stick with 160x120

			//-----------------------------------------------------------
			// Add to the database
			//-----------------------------------------------------------

			$Query = "UPDATE `wallpapers` SET `thumbSmall`='".$ThumbSmall."', `thumbLarge`='".$ThumbLarge."' WHERE `id`='".$Posted['wallid']."'";
			$this->class->mysql->Query($Query);

			// Fetch the id
			$Query = "SELECT `id` FROM `wallpapers` ORDER BY `id` DESC LIMIT 1";
			$res = $this->class->mysql->Query($Query);
			$id = $this->class->mysql->FetchResults($res);
			$id = $id[0]['id'];

			//-----------------------------------------------------------
			// Move the temporary file
			//-----------------------------------------------------------

			$wallFile = "wallpapers/".$Wallpaper['name']."_".$Wallpaper['width']."x".$Wallpaper['height']."_".$id.$Wallpaper['extension'];
			functions::resizeImage($Posted['path'],$wallFile,$Wallpaper['width'],$Wallpaper['height']);

			$Query = "DELETE FROM `wallpaper_uploads` WHERE `wid`='".$Posted['wallid']."'";
			$this->class->mysql->Query($Query);

			$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
					"VALUES('".$Posted['wallid']."','".$Wallpaper['width']."','".$Wallpaper['height']."','".$wallFile."')";
			$this->class->mysql->Query($Query);

			//-----------------------------------------------------------
			// Move all of the files
			//-----------------------------------------------------------

			if (count($Posted['Dimensions']) > 0)
			{
				foreach($Posted['Dimensions'] as $ide => $val)
				{
					if ($val == 'on') 
					{
						$tmp = explode("x",$ide);
						$Width = $tmp[0];
						$Height = $tmp[1];

						$wallFile = "wallpapers/".$Wallpaper['name']."_".$Width."x".$Height."_".$id.$Wallpaper['extension'];
						functions::resizeImage($Posted['path'],$wallFile,$Width,$Height);

						$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
								"VALUES('".$Posted['wallid']."','".$Width."','".$Height."','".$wallFile."')";
						$this->class->mysql->Query($Query);
					}
				}
			}
		}
		
		// Update
		$Query = "UPDATE `wallpapers` SET `name`='".$Posted['title']."', `desc`='".$Posted['description']."', `cat`=".$Posted['cat'].", `tags`='".$Posted['tags']."' WHERE `id`=".$Posted['wallid'];
		$Result = $this->class->mysql->Query($Query);

		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = $this->class->lang->Phrase['ucp_ed_ti'] . " - " . $this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
	
		
		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['wall_updated'],
		));

		$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div>';

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));		

		return $this->Output;
			
	}

	//---------------------------------------------------------
    // Name:    edit_wallpaper()
    // Desc:    Output the front end (editing the wallpaper).
    //---------------------------------------------------------

	function edit_wallpaper()
	{
		$this->return['path'] = "../../../../";
		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		if ($this->class->Data("action") == 'submit') 
			return $this->submit_edit_wallpaper();

		if (!is_numeric($this->class->Data("wallid")))
			$this->class->Error("inv_wid");

		$Query = "SELECT * FROM `wallpapers` WHERE `id`='".$this->class->Data("wallid")."'";
		$Result = $this->class->mysql->Query($Query);
		$Wallpaper = $this->class->mysql->FetchResults($Result);
		$Wallpaper = $Wallpaper[0];

		if (count($Wallpaper) == 0)
			$this->class->Error("wallpaper_noexist");

		if ($Wallpaper['author'] != $this->class->User['username'])
			$this->class->Error("You do not have permission to edit this wallpaper.");

		$this->class->page['title'] = $this->class->lang->Phrase['ucp_ed_ti'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		//-----------------------------------------------------------
		// Get the categories and subcategories
		//-----------------------------------------------------------

		$Query = "SELECT * FROM `categories`";
		$Res = $this->class->mysql->Query($Query);
		$Categories = $this->class->mysql->FetchResults($Res);

		$Structure = array();
		$Subs = array();
		foreach($Categories as $Cat) 
		{
			if ($Cat['parent'] == 0)
				$Structure[$Cat['id']] = array("name" => $Cat['name'], "Sub" => array());
			else $Subs[] = $Cat;
		}

		foreach($Subs as $Sub) 
			$Structure[$Sub['parent']]['Sub'][$Sub['id']] = $Sub['name'];

		asort($Structure);

		$Options = null;
		foreach($Structure as $id => $Cat)
		{
			$Extra = ($id == $Wallpaper['cat']) ? " selected" : null;
			$Options .= "<option value='".$id."'".$Extra.">".$Cat['name']."</option>\n";
			foreach($Cat['Sub'] as $sid => $scat) 
			{
				$Extra = ($sid == $Wallpaper['cat']) ? " selected" : null;
				$Options .= "<option value='".$sid."'".$Extra.">&nbsp;&nbsp;&nbsp;- ".$scat."</option>\n";
			}
		}

		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['user_wall_warning'],
		));

		//-----------------------------------------------------------
		// Lets output the user homepage
		//-----------------------------------------------------------

		$this->Output .= $this->class->template->LoadTemplate("login/wallpaper_edit.cphp", array(
			"Options"		=> $Options,
			"min_length"	=> 3,
			"message"		=> $Message,
			"title"			=> $Wallpaper['name'],
			"tags"			=> $Wallpaper['tags'],
			"description"	=> $Wallpaper['desc'],
			"thumb"			=> $Wallpaper['thumbLarge'],
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;		

	}

	//---------------------------------------------------------
    // Name:    edit()
    // Desc:    Front end: editing account settings.
    //---------------------------------------------------------
	
	function edit()
	{

		if ($this->class->Data("wallid") != null)
			return $this->edit_wallpaper();

		$this->return['path'] = "../";

		if (functions::check_logged() == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		// Variable
		$Options = null;

		$this->class->page['title'] = $this->class->lang->Phrase['ucp_ed_tit1'] . " - ".$this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		$comHTML = $this->Comments(5, $this->return['path']);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['ucp_ed_dec1'],
		));

		// Get the countries
		$Countries = functions::Countries(true,$this->class->User['country']);

		// Gender (1=male 2=female)
		$ext_male = ($this->class->User['gender'] == 1) ? ' SELECTED' : null;
		$ext_fema = ($this->class->User['gender'] == 2) ? ' SELECTED' : null;
		$Gender = "<option value='1'".$ext_male.">" . $this->class->lang->Phrase['gen_male'] . "</option><option value='2'".$ext_fema.">". $this->class->lang->Phrase['gen_female'] . "</option>";

		// Secret questions
		$Secret = null;
		foreach($this->class->lang->Phrase['secret_questions'] as $Question)
		{
			$ext = (strtolower($Question) == strtolower($this->class->User['secret_question'])) ? " SELECTED" : null;
			$Secret .= '<option value="'.$Question.'"'.$ext.'>'.$Question.'</option>';
		}

		//-----------------------------------------------------------
		// Lets output the user homepage
		//-----------------------------------------------------------

		$this->Output .= $this->class->template->LoadTemplate("login/user_edit.cphp", array(
			"Options"		=> $Options,
			"min_length"	=> 3,
			"message"		=> $Message,
			"email"			=> $this->class->User['email'],
			"name"			=> $this->class->User['name'],
			"countries"		=> $Countries,
			"gender"		=> $Gender,
			"secret"		=> $Secret,
			"about"			=> $this->class->User['about'],
		));

		$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
			"comments"		=> $comHTML,
		));

		

		return $this->Output;

	}

	//---------------------------------------------------------
    // Name:    logout()
    // Desc:    Process the logout.
    //---------------------------------------------------------

	function logout()
	{
		setcookie('username', null, time()+604800, "/");
		setcookie('password', null, time()+604800, "/");
		header("Location: ../login.html");

	}

	//---------------------------------------------------------
    // Name:    Comments(Amounth,Path)
    // Desc:    Retrieve the comments from the db.
    //---------------------------------------------------------
	
	function Comments($Amount,$Path)
	{
		// Initiate variable
		$comHTML = null;

		// Get unread comments
		$Query = "SELECT COUNT(*) FROM `messages` WHERE `to`='".$this->class->User['userid']."' AND `read`=0";
		$Result = $this->class->mysql->Query($Query);
		$Unread = $this->class->mysql->FetchResults($Result);
		$Unread = $Unread[0]['COUNT(*)'];

		if ($Unread > 0) 
		{
			$this->class->lang->Phrase['usr_unread'] = '&nbsp;<span style="font-size:10px; font-weight:bold; color: red;">('.$Unread.' ' . $this->class->lang->Phrase['x_new_msgs'] . ')</span>';
		} else
		{
			$this->class->lang->Phrase['usr_unread'] = '';
		}

		//-----------------------------------------------------------
		// Lets get the latest five comments
		//-----------------------------------------------------------

		$Query = "SELECT * FROM `messages` WHERE `to`='".$this->class->User['userid']."' ORDER BY `id` DESC LIMIT ".$Amount;
		$Res = $this->class->mysql->Query($Query);
		$Comments = $this->class->mysql->FetchResults($Res);

		$n = 0;
		foreach($Comments as $Comment)
		{
			$n++;
			$bgColor = (($n % 2) == 0) ? '#F9F9F9' : '#FFFFFF';

			$timeAgo = functions::TimeAgo($Comment['time']);

			$User = ($Comment['from'] == '-1') ? '<span style="font-weight:bold; text-decoration:underline;">' . $this->class->lang->Phrase['admin_tit'] . '</span>' : (($Comment['from'] == 0) ? $this->class->lang->Phrase['comment_guest'] : '<a href="#">' . $this->class->lang->Phrase['usr_title'] . '</a>');

			$Message = (strlen($Comment['message']) > 150) ? substr($Comment['message'],0,150) .'... <a href="'.$Path.'user/message/'.$Comment['id'].'/">' . $this->class->lang->Phrase['msg_r_mo'] . '</a>' : $Comment['message'];

			$comHTML .= $this->class->template->LoadTemplate("login/comment.cphp", array(
				"bgcolor"		=> $bgColor,
				"time"			=> $timeAgo[0]." ".$timeAgo[1],
				"message"		=> str_replace(array("<br />"), null,functions::format_message($Message,true)),
				"user"			=> $User,
			));
		}

		return $comHTML;
	}

	//---------------------------------------------------------
    // Name:    SubmitWallpaper()
    // Desc:    Process the submission of a wallpaper.
    //---------------------------------------------------------

	function SubmitWallpaper($skip=false, $path="a")
	{
		$this->return['path'] = $path == "a" ? "../" : $path;

		if (functions::check_logged() == false && $skip == false) {
			header("Location: ".$this->return['path']."login.html");
			return;
		}

		// Was captcha entered?
		if( $skip == true )
		{
			if(! empty($this->class->Settings['publickey']) && ! empty($this->class->Settings['privatekey']))
			{
				$resp = $this->class->Recaptcha->recaptcha_check_answer ($this->class->Settings['privatekey'],
						   $_SERVER["REMOTE_ADDR"],
						   $this->class->Data("recaptcha_challenge_field"),
						   $this->class->Data("recaptcha_response_field"));

				if (!$resp->is_valid)
					$this->class->Error( "inc_captcha" );
			}
		}

		//-----------------------------------------------------------
		// Lets just filter out the content
		//-----------------------------------------------------------

		$Posted = array();
		foreach($_REQUEST as $ide => $val)
			$Posted[$ide] = str_replace(array("'"), null, $this->class->Data($ide));

		$Dim = array();
		if (array_key_exists('Dimensions', $_REQUEST) && count($_REQUEST['Dimensions']) > 0) 
		{
			foreach($_REQUEST['Dimensions'] as $i => $v)
				$Dim[addslashes($i)] = addslashes($v);
		}

		$Posted['Dimensions'] = $Dim;

		$Posted['path'] = str_replace('../../', null, $Posted['path']);
		
		//-----------------------------------------------------------
		// Lets upload it!
		//-----------------------------------------------------------

		if ($Posted['title'] == null)
			$this->class->Error("no_wtitle");

		if ($Posted['tags'] == null)
			$this->class->Error("no_wtags");

		if ($Posted['description'] == null)
			$this->class->Error("no_wdesc");

		if ($Posted['cat'] == null || !is_numeric($Posted['cat']))
			$this->class->Error("inv_cid");

		//-----------------------------------------------------------
		// Upload the thumbnails (large and small)
		//-----------------------------------------------------------

		$Wallpaper['name'] = preg_replace("/([ ]+)/","_",strtolower($Posted['title']));
		$Wallpaper['extension'] = substr($Posted['path'], strrpos($Posted['path'],'.'));
		$Wallpaper['file'] = "thumbnails/";
		list($Wallpaper['width'],$Wallpaper['height']) = getimagesize($Posted['path']);

		$resizeRatio = $Wallpaper['width'] / 488;
		$Width = 488;
		$Height = round($Wallpaper['height'] / $resizeRatio,0);

		// Large thumbnail
		$ThumbLarge = $Wallpaper['file']."large_".$Wallpaper['name']."_".rand(1,100000).$Wallpaper['extension'];
		functions::resizeImage($Posted['path'],$ThumbLarge,$Width,$Height);

		// Small thumbnail
		$ThumbSmall = $Wallpaper['file'].$Wallpaper['name']."_".rand(10000,100000).$Wallpaper['extension'];
		functions::resizeImage($Posted['path'],$ThumbSmall,160,120); // Revision: stick with 160x120

		//-----------------------------------------------------------
		// Add to the database
		//-----------------------------------------------------------

		$User = array_key_exists("username", $this->class->User) ? $this->class->User['username'] : null;

		// Auto approve?
		$Status = $this->class->Settings['auto_approve_wallpapers'] == 1 ? 1 : 0;

		$Query = "INSERT INTO `wallpapers` (`cat`,`name`,`desc`,`thumbSmall`,`thumbLarge`,`tags`,`time`,`author`, `status`) VALUES(".
				"'".$Posted['cat']."','".$Posted['title']."','".$Posted['description']."','".$ThumbSmall."','".$ThumbLarge."','".$Posted['tags']."',".
				"'".time()."','".$User."', " . $Status . ")";

		$this->class->mysql->Query($Query);

		// Fetch the id
		$Query = "SELECT `id` FROM `wallpapers` ORDER BY `id` DESC LIMIT 1";
		$res = $this->class->mysql->Query($Query);
		$id = $this->class->mysql->FetchResults($res);
		$id = $id[0]['id'];

		//-----------------------------------------------------------
		// Move the temporary file
		//-----------------------------------------------------------

		$wallFile = "wallpapers/".$Wallpaper['name']."_".$Wallpaper['width']."x".$Wallpaper['height']."_".$id.$Wallpaper['extension'];
		functions::resizeImage($Posted['path'],$wallFile,$Wallpaper['width'],$Wallpaper['height']);

		$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
				"VALUES('".$id."','".$Wallpaper['width']."','".$Wallpaper['height']."','".$wallFile."')";
		$this->class->mysql->Query($Query);

		//-----------------------------------------------------------
		// Move all of the files
		//-----------------------------------------------------------

		if (count($Posted['Dimensions']) > 0)
		{
			foreach($Posted['Dimensions'] as $ide => $val)
			{
				if ($val == 'on') 
				{
					$tmp = explode("x",$ide);
					$Width = $tmp[0];
					$Height = $tmp[1];

					$wallFile = "wallpapers/".$Wallpaper['name']."_".$Width."x".$Height."_".$id.$Wallpaper['extension'];
					functions::resizeImage($Posted['path'],$wallFile,$Width,$Height);

					$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
							"VALUES('".$id."','".$Width."','".$Height."','".$wallFile."')";
					$this->class->mysql->Query($Query);
				}
			}
		}

		// Delete the temp file
		unlink($Posted['path']);

		//-----------------------------------------------------------
		// Lets output
		//-----------------------------------------------------------

		$this->class->page['title'] = $this->class->lang->Phrase['ucp_submitted'] . " - " . $this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		// Get the message
		$Message = $this->class->template->LoadTemplate("global/information.cphp", array(
			"message" => $this->class->lang->Phrase['ucp_wal_up_suc'],
		));

		$this->Output .= '<div style="float:left; width:450px;"><div style="float:left;">'.$Message.'</div><div style="float:left; width: 450px; height: 300px;">&nbsp;</div></div>';

		if (functions::check_logged() == true) 
		{
			$comHTML = $this->Comments(5, $this->return['path']);
			$this->Output .= $this->class->template->LoadTemplate("login/user_left.cphp", array(
				"comments"		=> $comHTML,
			));
		} else
		{
			$this->Output .= $this->class->template->LoadTemplate("misc/login_box.cphp", array());
		}


		

		return $this->Output;
		
	}

	//---------------------------------------------------------
    // Name:    login_form()
    // Desc:    Front end of a login form.
    //--------------------------------------------------------

	function login_form()
	{
		$this->return['path'] = "";
		$this->class->page['title'] = "Login - " . $this->class->Settings['Site_Title'];

		// Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		$Login = $this->class->Settings['users_login_by'] == '1' ? 'email' : 'username';
		$Caption = $this->class->Settings['users_login_by'] == '1' ? $this->class->lang->Phrase['log_em_ti'] : $this->class->lang->Phrase['usr_title'];

		// Message
		$Message = $this->class->template->LoadTemplate("global/error_custom.cphp", array(
			"message" => $this->class->lang->Phrase['signin_em'],
			"width"	=> 400,
		));

		$this->Output .= $this->class->template->LoadTemplate("login/login.cphp", array(
			"message"		=> $Message,
			'login'			=> $Login,
			'caption'		=> $Caption,
		));

		if (functions::check_logged() == true)
			header("Location: ".$this->return['path']."user/");
		else
			$this->Output .= $this->class->template->LoadTemplate("login/login_box.cphp", array());

		return $this->Output;
	}

	//---------------------------------------------------------
    // Name:    Emoticons()
    // Desc:    Output the emoticons.
    //---------------------------------------------------------

	function Emoticons()
	{
		//---------------------------------------
		// Let's get the smilies
		//---------------------------------------
		
		$Message = array();

		$dir = "images/smilies/";
		$emot = '';
		if (is_dir($dir))
		{
			if($d_handle = opendir("images/smilies/"))
			{
				while (($file = readdir($d_handle)) !== false) {
					if (strtolower(filetype($dir . $file)) == 'file' && substr($file,strrpos($file,".")) != '.db') 
					{
						$val = str_replace(substr($file,strrpos($file,".")),null,$file);
						#$Message[0]['message'] = str_replace("[".$val."]","<img src='".$this->return['path'].$dir.$file."'>",$Message[0]['message']);
						$emot .= '<a href="#" style="text-decoration: none; border:0px #FFF solid;" onclick="insertAtCursor(document.getElementById(\'reply_textarea\'), \'['.$val.']\'); return false;"><img src="'.$this->return['path'].$dir.$file.'" style="border:0px solid;" alt="'.$val.'" /></a>'."\n";
					}
				}
				closedir($d_handle);
			}
		}
		return $emot;
	}

	//---------------------------------------------------------
    // Name:    email()
    // Desc:    Email a user a wallpaper (called via Ajax)
    //---------------------------------------------------------

	function email()
	{
		$Email = $this->class->Data("recipient");
		if($Email == null)
			die($this->class->lang->Phrase['err_em_re']);

		if(strpos($Email, "@") == 0)
			die($this->class->lang->Phrase['err_inv_em']);

		$Id = $this->class->Data("wid");
		if($Id == null || ! is_numeric($Id))
			die($this->class->lang->Phrase['inv_wid']);

		// Fetch the wallpapers
		$Query = "SELECT wallpapers.name, categories.name AS category FROM `wallpapers` INNER JOIN `categories` ON wallpapers.cat = categories.id WHERE wallpapers.id = '" . $Id . "'";
		$Result = $this->class->mysql->Query($Query);
		$Wallpaper = $this->class->mysql->FetchResults($Result);
		$Wallpaper = $Wallpaper[0];
		
		// Url of wallpaper
		$Link = $this->class->Settings['Website_URL'];
		if(substr($Link, -1) != '/') $Link .= '/';

		$Url = $Link . str_replace(' ', $this->class->Settings['identifier'], strtolower(utf8_encode($Wallpaper['category']))) . '/' . str_replace(' ', $this->class->Settings['identifier'], utf8_encode(strtolower($Wallpaper['name'])));
		$Url .= $this->class->Settings['identifier'] . $Id . '.html';

		// Message
		$Message = $this->class->Settings['email_message'];
		$Message = str_replace('{Site_Title}', $this->class->Settings['Site_Title'], $Message);
		$Message = str_replace('{Wallpaper_Name}', $Wallpaper['name'], $Message);
		$Message = str_replace('{Link}', $Url, $Message);
		$Message = str_replace(array("\n", "\r", "\r\n"), "\r\n", $Message);

		$Domain = $this->class->Settings['Website_URL'];
		$Domain = str_ireplace(array('http://', 'www.'), null, $Domain);

		$Pattern = '/([\w\_\.\d]+)/';
		preg_match_all($Pattern, $Domain, $Dom);
		$Domain = $Dom[1][0];

		$From = 'automated@' . $Domain;
		$Title = $this->class->Settings['email_title'];

		functions::send_mail($Email, $Title, $Message, $From);
		die($this->class->lang->Phrase['em_wal_suc']);

	}

	//---------------------------------------------------------
    // Name:    forgot()
    // Desc:    Output the forgot your password form.
    //---------------------------------------------------------

	function forgot()
	{
		$this->return['path'] = functions::Path();

		if(functions::check_logged() == true)
			$this->class->Error( "alr_logged" );

		if($this->class->Data("email") != null || $this->class->Data("username") != null)
		{
			$Email = $this->class->Data('email');
			$Username = $this->class->Data('username');

			$Query = "SELECT COUNT(*), email, username, userid FROM `users` WHERE `username` = '" . $Username . "' OR `email` = '" . $Email . "'";
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);
			
			if( (int) $Res[0]['COUNT(*)'] == 0)
				$this->class->Error( "usr_ema_nof" );

			$Domain = $this->class->Settings['Website_URL'];
			$Domain = str_ireplace(array('http://', 'www.'), null, $Domain);

			$Pattern = '/([\w\_\.\d]+)/';
			preg_match_all($Pattern, $Domain, $Dom);
			$Domain = $Dom[1][0];

			$From = 'automated@' . $Domain;

			// Insert the new request
			$Password = rand('10000000', '99999999');
			$Rand = rand('10000000', '99999999');

			$Query = "INSERT INTO `pass_request` (date, expire, uid, ip, password, active, rand) VALUES(";
			$Query .= time() . ", " . ( time() + 3600 ) . ", " . $Res[0]['userid'] . ", '" . $this->class->IPAddr() . "', " . $Password . ", 1, " . $Rand . ")";
			$Result = $this->class->mysql->Query($Query);

			$Link = $this->class->Settings['Website_URL'];
			if(substr($Link, -1) != '/') $Link .= '/';
			$Link .= 'forgot.html?' . $Rand;

			$Message = $this->class->lang->Phrase['new_pw_msg'];
			$Message = str_replace('{username}', $Res[0]['username'], $Message);
			$Message = str_replace('{domain}', $Domain, $Message);
			$Message = str_replace('{link}', $Link, $Message);

			$Email = array(
				'to'		=> $Res[0]['email'],
				'subject'	=> $this->class->lang->Phrase['new_pw_req'],
				'from'		=> $From,
				'message'	=> $Message,
			);

			functions::send_mail($Email['to'], $Email['subject'], $Email['message'], $Email['from']);

			// Message has been sent
			$this->class->page['title'] = 'Forgot Password - '.$this->class->Settings['Site_Title'];

			$this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
			$this->Output .= $this->class->CompileCategories();
			$this->Output .= $this->class->CompilePartners();
			$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

			$html = $this->class->template->LoadTemplate("global/forgot_submit.cphp");
			
			$this->Output .= $html;

			return $this->Output;
		}

		// Are we resetting it?
		preg_match_all("/\?(\d+)/", $_SERVER['REQUEST_URI'], $Res);
		if(isset($Res[1][0]))
		{
			$Id = (int) $Res[1][0];

			$Query = "SELECT *, COUNT(*) FROM pass_request WHERE rand = '" . $Id . "' LIMIT 1";
			$Result = $this->class->mysql->Query($Query);
			$Request = $this->class->mysql->FetchResults($Result);
			$Request = $Request[0];

			if( (int) $Request['COUNT(*)'] == 0)
				$this->class->Error("forgot_err1");

			if( (int) $Request['expire'] < time() )
				$this->class->Error("forgot_err2");

			if( (int) $Request['active'] != 1)
				$this->class->Error("forgot_err3");

			// Update the password
			$Query = "UPDATE users SET password = '" . md5($Request['password']) . "' WHERE userid = " . $Request['uid'];
			$Result = $this->class->mysql->Query($Query);

			// Update the request
			$this->class->mysql->Query("UPDATE pass_request SET active = 0 WHERE rand = '" . $Id . "'");

			// All sorted. Let's email
			$Query = "SELECT COUNT(*), email, username, userid FROM `users` WHERE userid = " . $Request['uid'];
			$Result = $this->class->mysql->Query($Query);
			$Res = $this->class->mysql->FetchResults($Result);
			
			if( (int) $Res[0]['COUNT(*)'] == 0)
				$this->class->Error( "usr_ema_nof" );

			$Domain = $this->class->Settings['Website_URL'];
			$Domain = str_ireplace(array('http://', 'www.'), null, $Domain);

			$Pattern = '/([\w\_\.\d]+)/';
			preg_match_all($Pattern, $Domain, $Dom);
			$Domain = $Dom[1][0];

			$From = 'automated@' . $Domain;

			$Message = $this->class->lang->Phrase['new_pw_msg_2'];
			$Message = str_replace('{username}', $Res[0]['username'], $Message);
			$Message = str_replace('{domain}', $Domain, $Message);
			$Message = str_replace('{password}', $Request['password'], $Message);

			$Email = array(
				'to'		=> $Res[0]['email'],
				'subject'	=> $this->class->lang->Phrase['pass_ch2'],
				'from'		=> $From,
				'message'	=> $Message,
			);

			functions::send_mail($Email['to'], $Email['subject'], $Email['message'], $Email['from']);

			// Message has been sent
			$this->class->page['title'] = 'Forgot Password - '.$this->class->Settings['Site_Title'];

			$this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
			$this->Output .= $this->class->CompileCategories();
			$this->Output .= $this->class->CompilePartners();
			$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

			$html = $this->class->template->LoadTemplate("global/forgot_submit_2.cphp");
			
			$this->Output .= $html;

			return $this->Output;
		}

		$this->class->page['title'] = "Forgot Password - " . $this->class->Settings['Site_Title'];

		// Categories
        $Content = $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$Content .= $this->class->CompileCategories();
		$Content .= $this->class->CompilePartners();
		$Content .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		$Login = $this->class->Settings['users_login_by'] == '1' ? 'email' : 'username';
		$Caption = $this->class->Settings['users_login_by'] == '1' ? $this->class->lang->Phrase['log_em_ti'] : $this->class->lang->Phrase['usr_title'];

		// Message
		$Message = $this->class->template->LoadTemplate("global/error_custom.cphp", array(
			"message" => $this->class->lang->Phrase['forgot_msg'],
			"width"	=> 400,
		));


		$Content .= $this->class->template->LoadTemplate("login/forgot.cphp", array(
			"message"		=> $Message,
			'login'			=> $Login,
			'caption'		=> $Caption,
		));

		$Content .= $this->class->template->LoadTemplate("login/login_box.cphp", array());

		return $Content;

	}

}

?>