<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Plugins
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Last updated: Mar 29 2010
|	> Revisions: 9
|
+--------------------------------------------------------------------------
*/

class Plugins
{

	public $Settings;
	public $class;

	function auto_run()
	{
		Functions::$Var['Selected'] = 4;

		switch($this->class->main->Data("do"))
		{
			case 'do_add_setting':
				return $this->do_add_setting();
				break;
            case 'new_setting':
                return $this->add_setting();
                break;
            case 'submit_settings':
                return $this->submit_plugin_settings();
                break;
            case 'install':
                return $this->install();
                break;
            case 'dodelete':
                return $this->dodelete();
                break;
            case 'delete':
                return $this->delete();
                break;
            case 'submitadd':
                return $this->submitadd();
                break;
            case 'new_code':
                return $this->new_code();
                break;
			case 'submitedit':
				return $this->submitedit();
				break;
			case 'doedit':
				return $this->doedit();
				break;
			case 'edit':
				return $this->edit();
				break;
			case 'impex':
				return $this->impex_plugins();
				break;
			case 'submit_import':
				return $this->submit_import();
				break;
			default:
				return $this->showcase();
				break;
		}
	}

	function do_add_setting()
	{
		Functions::DemoCheck();

		if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];

		$Type = $this->class->main->Data( "type" );
		$Title = $this->class->main->Data( "title" );
		$Name = $this->class->main->Data( "name" );
		$Value = $this->class->main->Data( "value" );
		$Options = $this->class->main->Data( "options" );

		if(  $Type == '' ) Functions::AdminError( "You must enter a setting type." );
		if( $Title == '' ) Functions::AdminError( "You must enter a setting title." );
		if(  $Name == '' ) Functions::AdminError( "You must enter a setting name." );

		$Query = "INSERT INTO plugin_settings (`identifier`, `name`, `desc`, `value`, `type`, `options`) VALUES(";
		$Query .= "'{$Plugin['identifier']}', '$Name', '$Title', '$Value', '$Type', '$Options')";

		$this->class->main->mysql->Query( $Query );
		
		Functions::Redirect('Plugin setting has been added.' , 'index.php?act=plugins&do=edit&id=' . $Plugin['id']); 

	}

	public function getClass() {
		return $this;
	}
    
    function add_setting()
    {
		if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];
        
		$Submit = Functions::LoadTemplate( "submit_button", array( "caption" => "Add Plugin Setting" ) );
        $Out = Functions::LoadTemplate( "add_plugin_setting", array( 'submit' => $Submit, 'id' => $Plugin['id'] ) );
        return Functions::BuildSection( "Add Plugin Setting", $Out );
    }
    
    function submit_plugin_settings()
    {
		Functions::DemoCheck();

         if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];
        
        // Select plugin settings
        $Query = "SELECT * FROM `plugin_settings` WHERE `identifier` = '" . $Plugin['identifier'] . "'";
        $Result = $this->class->main->mysql->Query($Query);
		$Settings = $this->class->main->mysql->FetchResults($Result);
        
        $Setting = array();
        foreach( $Settings as $dbSetting )
        {
            $Setting[ $dbSetting['name'] ] = $dbSetting['value'];
        }
        
        foreach( $_POST as $Field => $Val )
		{
			if( isset( $Setting[$Field] ) )
			{
				// If different, update it.
				if( $Setting[$Field] != $Val )
				{
					$this->class->main->mysql->Query("UPDATE plugin_settings SET `value` = '" . mysql_real_escape_string( $Val ) . "' WHERE name = '" . mysql_real_escape_string( $Field ) . "' AND identifier = '" . $Plugin['identifier'] . "'");
				}
			}
		}
        
        Functions::Redirect('Plugin settings have been updated.' , 'index.php?act=plugins&do=edit&id=' . $Plugin['id']); 
        
    }
    
    function install()
    {
		Functions::DemoCheck();

        if(! isset($_REQUEST['fn']))
			Functions::AdminError("You must enter a plugin id.");
            
        // Does the plugin file exist?
        $Name = $this->class->main->Data("fn");
        $Dir = "includes/plugins/xml/";
        $Include = $Dir . $Name . '.xml';
        
        if( ! file_exists( $Include ) )
            Functions::AdminError( "Plugin xml file does not exist." );

        $XML = simplexml_load_file( $Include );
        $Plugin = get_object_vars($XML);
        
        // Plugin details
        $Product = mysql_real_escape_string( $Plugin['identifier'] );
        
        if( ! file_exists( $Plugin['install'] ) )
            functions::AdminError( "Installation xml file does not exist." );
            
        $Install = simplexml_load_file( $Plugin['install'] );

		$QPlugin = array_map("mysql_real_escape_string", $Plugin);

		// Minimum PHP version to run?
		if( isset( $Install->minversion ) ) {
			if( (float) $Install->minversion > VERSION ) {
				functions::AdminError( "This plugin requires WallScript " . $Install->minversion . " to run. You currently have " . VERSION . ". Please update." );
			}
		}

		// Do we have any custom queries to run?
		if( isset( $Install->extra->query) && is_object( $Install->extra->query ) ) {
			foreach( $Install->extra->query as $Query ) {
				$this->class->main->mysql->Query( $Query );
			}
		}

		// Let's install the plugin settings
		if( is_object( $Install->settings ) )
		{
			foreach( $Install->settings->setting as $Setting )
			{
				$arrSet = get_object_vars( $Setting );

				$Name = mysql_real_escape_string( $arrSet['name'] ); // Required
				$Desc = mysql_real_escape_string( $arrSet['desc'] ); // Required
				$Value = ( isset( $arrSet['value'] ) ) ? mysql_real_escape_string( $arrSet['value'] ) : null; //Optional
				$Type = ( isset( $arrSet['type'] ) ) ? mysql_real_escape_string( $arrSet['type'] ) : null; //Optional
				$Options = ( isset( $arrSet['options'] ) ) ? mysql_real_escape_string( $arrSet['options'] ) : null; //Optional

				$Query = "INSERT INTO plugin_settings(`identifier`, `name`, `desc`, `value`, `type`, `options`) VALUES(";
				$Query .= "'{$QPlugin['identifier']}', '$Name', '$Desc', '$Value', '$Type', '$Options')";

				$this->class->main->mysql->Query($Query);
			}
		}

        // Let's install the plugin_codes
		if( is_object( $Install->code ) )
		{
			foreach( $Install->code->code_install as $Code_Install )
			{
				$cInstall = get_object_vars( $Code_Install);
				$Name = mysql_real_escape_string( $cInstall['name'] );
				$Script = mysql_real_escape_string( $cInstall['script'] );
				$FQuery = mysql_real_escape_string( $cInstall['query'] );
				$Called = (int) mysql_real_escape_string( $cInstall['called'] );
				$Code = mysql_real_escape_string( (string) $cInstall['code'] );
				$Template = mysql_real_escape_string( $cInstall['template'] );
				$TemplateDir = isset( $cInstall['templatedir'] ) ? mysql_real_escape_string( $cInstall['templatedir'] ) : null;
				
				$Query = "INSERT INTO plugin_code(product, name, script, query, code, called, template, TemplateDir) ";
				$Query .= "VALUES('$Product', '$Name', '$Script', '$FQuery', '$Code', '$Called', '$Template', '$TemplateDir')";
				
				$this->class->main->mysql->Query( $Query );
			}
		}

        
        // Install the main plugin
        $Query = "INSERT INTO plugins (name, identifier, class, filepath, installed, version, description) VALUES(";
        $Query .= "'{$QPlugin['name']}', '{$QPlugin['identifier']}', '{$QPlugin['class']}', '{$QPlugin['filepath']}', 1, '{$QPlugin['version']}', '{$QPlugin['description']}')";

        $this->class->main->mysql->Query( $Query );
        
        // All done, let's redirect
        Functions::Redirect('Plugin has been successfully installed.' , 'index.php?act=plugins');        
            
    }
    
    function dodelete()
    {
		Functions::DemoCheck();

         // Did we even enter a plugin id.
        if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

        // Let's see if the plugin exists.
		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];
        
        $Id = (int) $this->class->main->Data("id");
        
        // Remove the main plugin from the database
        $Query = "DELETE FROM plugins WHERE id = " . $Id;
        $Result = $this->class->main->mysql->Query($Query);
        
        // Delete plugin codes
        $Query = "DELETE FROM plugin_code WHERE product = '" . $Plugin['identifier'] . "'";
        $Result = $this->class->main->mysql->Query($Query);

		// Delete plugin settings
		$this->class->main->mysql->Query( "DELETE FROM plugin_settings WHERE identifier = '" . $Plugin['identifier'] . "'" );
        
        Functions::Redirect('Your plugin has been deleted.' , 'index.php?act=plugins');        
        
    }
    
    function delete()
    {
         // Did we even enter a plugin id.
        if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

        // Let's see if the plugin exists.
		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];
        
        $HTML = Functions::LoadTemplate( "delete_plugin_confirm", $Plugin );
        $HTML = Functions::BuildSection( "Remove Plugin", $HTML );
        
        return $HTML;
    }
    
    function submitadd()
    {
		Functions::DemoCheck();

        // Did we even enter a plugin id.
        if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

        // Let's see if the plugin exists.
		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];
            
        // Let's retrieve post data.
        $Posted = array();
        $Posted['name'] = $this->class->main->Data("name");
        $Posted['script'] = $this->class->main->Data("script");
        $Posted['query'] = $this->class->main->Data("query");
        $Posted['called'] = $this->class->main->Data("called");
        $Posted['template'] = $this->class->main->Data("template");
        $Posted['code'] = mysql_real_escape_string($_POST['code']);
        
        // If we didn't enter a name.
        if($Posted['name'] == null)
            Functions::AdminError("You must enter an identifying name for your plugin code.");
            
        // If we left fields empty, lets resort to default value.
        if(empty($Posted['script'])) $Posted['script'] = '*';
        if(empty($Posted['query'])) $Posted['query'] = '*';
        if(empty($Posted['called']) || ! is_numeric($Posted['called'])) $Posted['called'] = -1;
        
        // If we entered a template, lets make sure that it first exists.
        if( $Posted['template'] != null )
        {
            if( ! file_exists( "../" . $this->class->main->Settings['Template'] . "templates/" . $Posted['template'] . '.cphp' ) && ! file_exists( "../" . $this->class->main->Settings['Template'] . "templates" . $Posted['template'] . '.html' ) )
            {
                Functions::AdminError( "The template you are trying to call from does not exist." );
            }
        }
        
        // Did we enter any code?
        if( empty( $Posted['code'] ) )
            Functions::AdminError( "You must enter some code to inject. " );
            
        // All checks out, let's add to the database
        $Query = "INSERT INTO plugin_code (product, name, script, query, code, called, template) VALUES('" . $Plugin['identifier'] . "', '{$Posted['name']}', '{$Posted['script']}', '{$Posted['query']}', '{$Posted['code']}', '{$Posted['called']}', '{$Posted['template']}')";
        $Result = $this->class->main->mysql->Query($Query);
        
        // All's done, let's redirect.
		Functions::Redirect('Your plugin code has been added.' , 'index.php?act=plugins&do=edit&id=' . $Plugin['id']);        
        
    }
    
    function new_code()
    {
   	    if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];
        
        $HTML = Functions::LoadTemplate( "add_plugin_code", $Plugin );
		
		return Functions::BuildSection( "Add Plugin Code", $HTML );
        
    }

	function submitedit()
	{
		Functions::DemoCheck();

		if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin code id.");

		$Query = "SELECT *, COUNT(*) FROM `plugin_code` WHERE `id` = '" . $this->class->main->Data("id") . "' OR product = '" . $this->class->main->data("id") . "' GROUP BY id";
		$Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		$Plugin = $Plugin[0];

		if((int) $Plugin['COUNT(*)'] == 0)
			Functions::AdminError("Plugin code does not exist.");

		$Query = array();
		foreach( $_POST as $Field => $Val )
		{
			if( isset( $Plugin[$Field] ) )
			{
				// If different, update it.
				if( $Plugin[$Field] != $Val )
				{
					$this->class->main->mysql->Query("UPDATE plugin_code SET `" . mysql_real_escape_string($Field) . "` = '" . mysql_real_escape_string( $Val ) . "' WHERE id = '" . $this->class->main->Data("id") . "'");
				}
			}
		}

		Functions::Redirect('Your plugin settings have been updated.' , 'index.php?act=plugins&do=edit&id=' . $Plugin['product']);

	}

	function doedit()
	{
		if(! isset($_REQUEST['code_name']))
			Functions::AdminError("You must enter a plugin code id.");

        $Query = "SELECT *, COUNT(*) FROM `plugin_code` WHERE `id` = '" . $this->class->main->Data("code_name") . "' OR product = '" . $this->class->main->Data("code_name") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		$Plugin = $Plugin[0];

		if((int) $Plugin['COUNT(*)'] == 0)
			Functions::AdminError("Plugin code does not exist.");

		$HTML = Functions::LoadTemplate( "edit_plugin_code", $Plugin );
		
		return Functions::BuildSection( "Edit Plugin Code", $HTML );

	}

	function submit_import()
	{
		Functions::DemoCheck();

		if ($_FILES['file']['name'] == NULL) 
			Functions::AdminError('You must upload a file in order to submit a new theme.');;

		$name = "tmp/import-" . rand(1,1000000) . ".php";

		$upload = move_uploaded_file($_FILES['file']['tmp_name'], $name);

		if (!$upload)
			Functions::AdminError('Could not upload text file.');

		include_once($name);

		
		if(isset($Query) && isset($Query[0]) && is_array($Query))
			foreach($Query as $Q)
				$this->class->main->mysql->Query($Q);

		Functions::Redirect( 'Plugin has been uploaded.', 'index.php?act=plugins' );


	}

	function impex_plugins()
	{
		$ret = Functions::LoadTemplate('import_plugin');

		// Build it from the template
		$Section = Functions::BuildSection("Import Plugins", $ret);

		return $Section;

	}

	function edit()
	{
		if(! isset($_REQUEST['id']))
			Functions::AdminError("You must enter a plugin id.");

		$Query = "SELECT *, COUNT(*) FROM `plugins` WHERE `id` = '" . $this->class->main->Data("id") . "' OR identifier = '" . $this->class->main->Data("id") . "' GROUP BY id";
        $Result = $this->class->main->mysql->Query($Query);
		$Plugin = $this->class->main->mysql->FetchResults($Result);
		
        if( count($Plugin) == 0)
            Functions::AdminError("Plugin does not exist or has not yet been installed.");
            
        $Plugin = $Plugin[0];

		Functions::$Var['n'] = 0;
		Functions::$Var['y'] = 0;
		
		// Select plugin code
		$Query = "SELECT * FROM plugin_code WHERE product = '" . $Plugin['identifier'] . "'";
		$Result = $this->class->main->mysql->Query($Query);
		$Codes = $this->class->main->mysql->FetchResults($Result);

		$Options = null;
		foreach($Codes as $Code)
			$Options .= "<option value='" . $Code['id'] . "'>" . $Code['name'] . "</option>\n";

		$return = Functions::LoadTemplate("edit_plugin_codes", array("options" => $Options, "id" => $Plugin['id']));
		$return = Functions::BuildSection("Edit Plugin Code Injections", $return);

		$Class = $Plugin['class'];
		$Path = $Plugin['filepath'];

		// Let's fetch the settings
		$Query = "SELECT * FROM `plugin_settings` WHERE `identifier` = '" . $Plugin['identifier'] . "'";
		$Result = $this->class->main->mysql->Query($Query);
		$Settings = $this->class->main->mysql->FetchResults($Result);

		$Out = "Edit the settings below to toggle the selected plugin. To add a new setting, click <a href='?act=plugins&do=new_setting&id=" . $Plugin['id'] . "'>here</a>.<br /><br /><table class='tblsettings' cellpadding=4>";
		foreach($Settings as $Setting)
		{
			// Are we outputting options?
			if( $Setting['options'] != null )
			{
				$tmp = explode(";", $Setting['options']);
				$Options = null;

				foreach( $tmp as $Opt ) 
				{
					$tmp2 = explode("=", $Opt);
					if( isset( $tmp2[1] ) ) {
                        $Extra = ($Setting['value'] == $tmp2[0]) ? " selected" : null;
						$Options .= "<option value='" . $tmp2[0] . "'" . $Extra . ">" . $tmp2[1] . "</option>\n";
					}
				}
			}

			// Table
			$Out .= "<tr>\n<td style='width: 100px;'>" . $Setting['desc'] . ":</td><td>";

			switch( strtolower( $Setting['type'] ) ) 
			{
				case 'select':
					$Out .= '<select name="' . $Setting['name'] . "\">\n" . $Options . "</select>";
					break;
				case 'select multi':
					$Out .= '<select name="' . $Setting['name'] . "\" multiple=\"yes\" size=\"4\">\n" . $Options . "</select>";
					break;
				case 'textarea':
					$Out .= "<textarea name='" . $Setting['name'] . "' style='width: 250px; height: 80px; font-family: tahoma; font-size: 12px;'>" . $Setting['value'] . "</textarea>";
					break;
				default:
					$Out .= '<input type="text" name="' . $Setting['name'] . '" value="' . $Setting['value'] . '" />';
					break;
			}

			// Wrap table
			$Out .= "</td>\n</tr>\n";
		}
		
		$Out .= "</table><br />";
        $Out .= Functions::LoadTemplate( "submit_button", array( "caption" => "Update Settings" ) );
        $Out = Functions::LoadTemplate("form", array("action" => '?act=plugins&do=submit_settings&id=' . $Plugin['id'], 'class' => 'search_form general_form', 'method' => 'post', 'content' => $Out, 'id' => ''), 0, false);


		// Let's output the settings
		$return .= Functions::BuildSection("Edit Plugin Settings", $Out);

		// Do we have a custom class to display?
		if( $Plugin['filepath'] != null && file_exists( $Plugin['filepath'] ) )
		{
			include_once($Path);
			$PluginClass = new $Class( $this->class->main );
			$Output = $PluginClass->Output();

			$return .= Functions::BuildSection( "Custom Plugin Class", $Output );
		}

		return $return;
	}

	function showcase()
	{
		// Table content
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_plugin_table_start", array());

		$Query = "SELECT * FROM `plugins` ORDER BY `name`";
		$Result = $this->class->main->mysql->Query($Query);
		$dbPlugins = $this->class->main->mysql->FetchResults( $Result );

		// Sort installed plugins into an array
		$Installed = array();
		foreach($dbPlugins as $Plug)
			$Installed[] = $Plug['identifier'];
		
		// Open xml plugin files
		$dir = "includes/plugins/xml/";
		if (is_dir($dir)) 
		{
			if ($dh = opendir($dir)) 
			{
				while (($file = readdir($dh)) !== false)
				{
					if(substr( $file, 0, 1 ) != '.' && strtolower(filetype($dir . $file)) == "file")
					{
						$filetype = substr($file, strrpos($file, ".", 3) + 1);
						if(strtolower($filetype) == "xml")
						{
							$Plugins[ str_replace( '.' . $filetype, null, $file ) ] = $dir . $file;
						}
					}
				}
				closedir($dh);
			}
		}

        // Loop through and display the plugins
		foreach($Plugins as $Filename => $Plugin)
		{
			$XML = Functions::xml2array($Plugin);
			$XML = $XML['plugin'];

			$PInstalled = in_array($XML['identifier'], $Installed) ? true : false;
            
			$Plugin = $XML;
			$Plugin['Install'] = ( $PInstalled == true ) ? 'Yes' : '<a href="?act=plugins&do=install&fn=' . $Filename . '">Install now</a>';
            $Plugin['id'] = $Plugin['identifier'];

			$tbl .= Functions::LoadTemplate("wrapper_plugin_entry", $Plugin);
		}

		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("table_plugin_options", array());

		// Build it from the template
		$Section = Functions::BuildSection("Manage Plugins", $tbl, array('table' => 1));

		return $Section;

	}

}


?>