<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Bulk
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Bulk
{

	//---------------------------------------------------------
    // Name:    start_bulk()
    // Desc:    Let's bulk upload those wallpapers
    //---------------------------------------------------------

	var $Var;

	function auto_run()
	{		
		$Path = "";

		$Id = '%id%';
		$Start = '%start%';

		// Run for four hours
		set_time_limit(14400);

		// Grab ID from URL
		if($_GET['start'] != null) $Start = addslashes($_GET['start']);

		if($Start == '0')
		{
			$HTML = $this->LoadTemplate("bulk_status", array('UniqId' => $Id));
			$HTML .= "<br /><iframe id='bulkLoad' src='" . $Id. '_tmp.php' . "?act=bulk&id={$UniqId}&start=1' style='width:800px; height:400px; display: block;'></iframe>";

			return $HTML;
		}

		if($Id == null) die("You must enter an id.");

		// Select the bulk session from the database
		$Query = "SELECT * FROM `admin_bulk` WHERE `rand` = '" . $Id . "'";
		$Result = mysql_query($Query) or die(mysql_error());
		$Bulk = mysql_fetch_assoc($Result);

		//---------------------------------------
		// Sort the folders in to an array
		//---------------------------------------

		$tmp = $Bulk['folders'];
		$tmp = explode("|_|_|", $tmp);

		$Folders = array();
		$Total = array();

		// Loop through the folders
		foreach($tmp as $Folder)
		{
			// Do we have a valid folder?
			if(! is_null($Folder) && $Folder != null)
			{
				if(substr($Folder, 0, 1) == " ")
					$Folder = substr($Folder, -(strlen($Folder)-1));

				if(!is_null($Folder) && $Folder != null)
					$Folders[] = $Folder;

				// Get the files in the folder (needed to find total files for percentage)
				$tmp = $this->FolderImages($Path."../bulk/" . $Folder);
				$Total = array_merge($Total, $tmp);
			}
		}

		// Total files we're going to upload.
		$Total = count($Total);

		//---------------------------------------
		// Sort out the dimensions
		//---------------------------------------

		// Grab dimensions from database
		$Dimensions = '1024x768|1152x864|1280x1024|1600x1200|1920x1440|2560x1920|1280x800|1440x900|1680x1050|1920x1200|2560x1600';

		// Explode in to array
		$tmpDim = explode("|",$Dimensions);
		$wDimensions = array();

		// Suffix
		$Suffix = 1;

		// Find aspect ratio of each dimension, do we really want to do it?
		foreach($tmpDim as $val) 
		{
			$tmpDimTwo = explode("x",$val);
			$wDimensions[] = array("width" => $tmpDimTwo[0], "height" => $tmpDimTwo[1], "ratio" => $this->Ratio($tmpDimTwo[0], $tmpDimTwo[1]));
		}	

		// Max amount of pixels (squared) in an image (too large can result in a memory error)
		$Max = 3300 * 3300;

		//---------------------------------------
		// Let's upload the wallpapers
		//---------------------------------------

		// Amount of wallpapers uploaded (used for status)
		$Done = 0;	

		// Loop through each of the folders we want to upload from.
		foreach($Folders as $Folder)
		{
		
			// Folder images
			$tmp = $this->FolderImages($Path."../bulk/" . $Folder);

			// Loop through the files in each folder
			foreach($tmp as $File)
			{	
				//-----------------------------------------------------------
				// Upload the thumbnails (large and small)
				//-----------------------------------------------------------

				$Wallpaper = array();

				// Use file name
				if($Bulk['names'] == '1')
				{
					$Name = str_ireplace(array(".jpg", ".gif", ".png", ".jpeg", ".x-png", "bmp"), null, $File);
					$Name = substr($Name, strrpos($Name, "/") + 1, strlen($Name) - 1);
				} else $Name = $Folder;

				// Are we stripping special characters from the name?
				if($Bulk['special'] == '1')
					$Name = $this->strip_chars($Name);
				
				// Are we stripping the numbers?
				if($Bulk['numbers'] == '1')
					$Name = preg_replace("/\d/", null, $Name);

				// Capitalizing first letter of each word?
				if($Bulk['capitalize'] == '1')
					$Name = ucwords(strtolower($Name));

				// Need to grab the tags now
				$Wallpaper['tags'] = str_replace(' ', ',', strtolower($Name));

				// Do we want an ordered suffix?
				if($Bulk['ordered'] == '1') $Name .= " " . $Suffix;

				// Sort wallpaper details in to array.
				$Wallpaper['name'] = $Name;
				$Wallpaper['escape_name'] = str_replace('+', '_', urlencode($Wallpaper['name']));
				$Wallpaper['extension'] = substr($File, strrpos($File,'.'));
				$Wallpaper['file'] = "thumbnails/";

				// Wallpaper width and height.
				list($Wallpaper['width'],$Wallpaper['height']) = getimagesize($File);
				$Width = $Wallpaper['width'];
				$Height = $Wallpaper['height'];	
				
				// Aspect ratio of the wallpaper.
				$Ratio = $this->Ratio($Wallpaper['width'], $Wallpaper['height']);

				// Let's sort out the wallpaper dimensions
				$Sizes = array();
				foreach($wDimensions as $Dime) 
					if ($Dime['width'] != $Wallpaper['width'] && $Dime['height'] != $Wallpaper['height']) // Different wallpaper
						if($Dime['ratio'] == $Ratio && intval($Dime['width']) < intval($Width) && intval($Dime['height']) < intval($Height)) // Same ratio, we can use it.
							$Sizes[] = $Dime['width']."x".$Dime['height'];
			
				// Large thumbnail width/height settings.
				$resizeRatio = $Wallpaper['width'] / 488;
				$Width = 488;
				$Height = round($Wallpaper['height'] / $resizeRatio,0);

				// Is the file too large?
				if(intval($Wallpaper['height']) * intval($Wallpaper['width']) < $Max)
				{
					// Increment suffix
					$Suffix++;

					// Large thumbnail
					$ThumbLarge = $Wallpaper['file'] . "large_".$Wallpaper['escape_name']."_".rand(1,100000).$Wallpaper['extension'];
					$this->resizeImage($File, $Path.'../' . $ThumbLarge, $Width, $Height);

					// Small thumbnail
					$ThumbSmall = $Wallpaper['file'].$Wallpaper['escape_name']."_".rand(10000,100000).$Wallpaper['extension'];
					$this->resizeImage($File, $Path.'../' . $ThumbSmall, 160, 120); // Revision: stick with 160x120

					//-----------------------------------------------------------
					// Add to the database
					//-----------------------------------------------------------

					#tmp1$User = $this->class->Admin['username'];
					$User = 'Admin';

					$Query = "INSERT INTO `wallpapers` (`cat`,`name`,`desc`,`thumbSmall`,`thumbLarge`,`tags`,`time`,`author`,`status`) VALUES(".
							"'".$Bulk['cat']."','".$Wallpaper['name']."','".$Wallpaper['name']."','".$ThumbSmall."','".$ThumbLarge."','".$Wallpaper['tags']."',".
							"'".time()."','".$User."', 1)";

					mysql_query($Query) or die(mysql_error());

					// Fetch the id
					$Query = "SELECT `id` FROM `wallpapers` ORDER BY `id` DESC LIMIT 1";
					$res = mysql_query($Query);
					$id = mysql_fetch_assoc($res);
					$id = $id['id'];

					//-----------------------------------------------------------
					// Move the temporary file
					//-----------------------------------------------------------

					$wallFile = "wallpapers/".$Wallpaper['escape_name']."_".$Wallpaper['width']."x".$Wallpaper['height']."_".$id.$Wallpaper['extension'];
					$this->resizeImage($File, $Path.'../' . $wallFile, $Wallpaper['width'], $Wallpaper['height']);

					$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
							"VALUES('".$id."','".$Wallpaper['width']."','".$Wallpaper['height']."','".$wallFile."')";
					mysql_query($Query);

					//-----------------------------------------------------------
					// Move all of the files
					//-----------------------------------------------------------

					if (count($Sizes) > 0)
					{
						foreach($Sizes as $ide => $val)
						{
							// Are we resizing the wallpaper?
							if ($Bulk['resize'] == '1') 
							{
								// Width and height to resize to.
								$tmp = explode("x",$val);
								$Width = $tmp[0];
								$Height = $tmp[1];

								// Physically resize wallpaper and move to proper directory.
								$wallFile = "wallpapers/".$Wallpaper['escape_name']."_".$Width."x".$Height."_".$id.$Wallpaper['extension'];
								$this->resizeImage($File, $Path.'../' . $wallFile, $Width, $Height);

								// Insert resized wallpaper in to the database.
								$Query = "INSERT INTO `wallpaper_uploads` (`wid`,`width`,`height`,`url`) ".
										"VALUES('".$id."','".$Width."','".$Height."','".$wallFile."')";
								mysql_query($Query);
							}
						}
					}

					// Just another wallpaper processed.
					$Done++;

					// Finished it for this wallpaper
					$Perc = round($Done / $Total * 100);

					// Update the percentage of wallpapers done.
					if($Perc == 100)
						$Query = "UPDATE `admin_bulk` SET `complete` = '100', `end` = '" . time() . "', `last_update` = " . time() . " WHERE `id` = " . $Bulk['id'];
					else  $Query = "UPDATE `admin_bulk` SET `complete` = '$Perc', `last_update` = " . time() . " WHERE `id` = ".$Bulk['id'];

					$Result = mysql_query($Query);
					
				} else $Done++;
			}

			// Are we deleting the folder?
			if($Bulk['delete'] == '1')
				$this->delete_directory($Path."../bulk/" . $Folder);
		}

		// Delete the files
		#unlink($Path."tmp/" . $Id . "_bulk.php");
		#unlink($Path.$Id . "_tmp.php");

		exit;
	}

	function delete_directory($dirname)
	{
		if (is_dir($dirname))
		  $dir_handle = opendir($dirname);

		if (!$dir_handle)
		  return false;

		while($file = readdir($dir_handle))
		{
			if ($file != "." && $file != "..")
			{
				if (!is_dir($dirname."/".$file))
					unlink($dirname."/".$file);
				else
					delete_directory($dirname.'/'.$file);    
			}
		}

		closedir($dir_handle);
		rmdir($dirname);

		return true;
	}

	//-----------------------------------------------
	// Load template function
	//-----------------------------------------------

	function LoadTemplate($template="", $replace = array(), $ignheaderfooter=0)
	{
		if($this->str_contains($template, "templates/") == false)
			$template = "templates/" . $template;

		if($this->str_contains($template, ".html") == false && $this->str_contains($template, ".cphp") == false)
			$template .= ".html";

		$return = file_get_contents( $template );
		if(is_array($replace) && count($replace) > 0)
		{
			foreach ($replace as $identifier => $value)
				$return = str_replace( array('&&' . $identifier . '&&', '{' . $identifier . '}') , $value , $return);
		}
		
		// Replace PHP code
		while($this->str_contains($return, '<php>', true) == true)
		{
			$Code = $this->GetStringBetween($return, '<php>', '</php>');

			// Whether the variable is in there or not.
			$php = null;
			if($this->str_contains($Code, '$php') == true)
				$Executed = eval($Code);
			else eval('$php = '.$Code);

			$return = str_replace('<php>' . $Code . '</php>', $php, $return);
		}

		return $return;
	}

	function GrabCategories()
	{
		// Get the categories and subcategories
		$Query = "SELECT * FROM `categories`";
		$Res = $this->Var['class']->mysql->Query($Query);
		$Categories = $this->Var['class']->mysql->FetchResults($Res);

		$Structure = array();
		$Subs = array();
		foreach($Categories as $Cat) 
		{
			if ($Cat['parent'] == 0)
				$Structure[$Cat['id']] = array("name" => $Cat['name'], "Sub" => array());
			else $Subs[] = $Cat;
		}

		foreach($Subs as $Sub) 
			$Structure[$Sub['parent']]['Sub'][$Sub['id']] = $Sub['name'];

		asort($Structure);
		return $Structure;
	}

	function CategoriesOptions()
	{
		$Structure = $this->GrabCategories();
		$Options = null;
		foreach($Structure as $id => $Cat)
		{
			$Options .= "<option value='".$id."'>".$Cat['name']."</option>\n";
			foreach($Cat['Sub'] as $sid => $scat)
				$Options .= "<option value='".$sid."'>&nbsp;&nbsp;&nbsp;&#0124;-- ".$scat."</option>\n";
		}

		return $Options;
	}

	//------------------------------------------------
	// Build a section
	//------------------------------------------------

	function BuildSection($Title, $Content, $Options = array())
	{
		//---------------------------------------
		// Load the templates
		//---------------------------------------

		// Table or normal template?
		$HTML = (array_key_exists('table', $Options) && $Options['table'] == 1) ? $this->LoadTemplate("table_section", array()) : $this->LoadTemplate("start_section", array());

		$HTML .= $this->LoadTemplate("section_title", array('Title' => $Title));
		$HTML .= $this->LoadTemplate("section_content", array('Content' => $Content));
		$HTML .= $this->LoadTemplate("end_section", array());
		
		// Return
		return $HTML;
	}

	//------------------------------------------------
	// Search a string for specific text
	//------------------------------------------------

	function str_contains($haystack, $needle, $sensitive = false)
	{
		if($sensitive == false)	return strpos($haystack, $needle) == 0 ? false : true;
		else return stripos($haystack, $needle) == 0 ? false : true;
	}

	//------------------------------------------------
	// Admin Error
	//------------------------------------------------

	function AdminError($Message)
	{
		$Message .= '&nbsp;&nbsp;<a href="#" style="color: #AE2727;" onclick="history.go(-1); return false;">Back</a>';

		$Error = $this->LoadTemplate("messages/error", array('message' => $Message, 'ext' => ' style="padding:0px; margin-top: 0px; padding-bottom: 0px;"'));
		$pageHTML = $this->BuildSection('The script has encountered an error!',$Error);

		echo $this->BuildPage($pageHTML);
		exit;
	}

	//------------------------------------------------
	// Redirect
	//------------------------------------------------

	function Redirect($Title, $URL, $Delay = 3)
	{
			$replaceVariables=array(
					"title" => $Title,
					"url" => $URL,
					"delay" => $Delay,
			);

			$html=$this->LoadTemplate("loading",$replaceVariables);
			echo $html;
			exit;
	}

	//------------------------------------------------
	// Build the page
	//------------------------------------------------

	function BuildPage($Content)
	{
		
		$header=$this->LoadTemplate("header",$Replace);

		// Need to get the top navigation.
		if(is_null($this->Var['Selected'])) $this->Var['Selected'] = 1;
		$Navigation = $this->LoadTemplate("top_nav", $navArray);

		// Page Source
		$Source = $header . $Navigation;

		// Content
		$pageHTML = $this->LoadTemplate("page", array(
				'Content'		=> $Content,	
		));

		//-----------------------------------------------
		// Side panel template
		//-----------------------------------------------
		
		// Grab the calender date
		$this->NewClass("includes/private/calendar.php", "Calendar", "this->Calendar");
		$Cal = $this->Calendar->Output();

		$sidePanel = $this->LoadTemplate("side", array(
			'calendar'		=> $Cal,	
		));

		// Get the footer
		$Footer = $this->LoadTemplate("footer", array());

		$page = $Source . $pageHTML . $sidePanel . $Footer;
		return $page;

	}

	//--------------------------------------------------
	// Find all images in a folder
	//--------------------------------------------------

	function FolderImages($dir = "c:/server/www/dev/wp",$tab="")
	{
		global $n;
		global $y;
		global $start;
		global $lines;
		global $output;
		global $len;
		global $words;

		$this->Var['n']++;
		if ($this->Var['n']==1000)
			exit;

		$Return = array();

		// Open a known directory, and proceed to read its contents
		if (is_dir($dir)) 
		{
			if ($dh = opendir($dir))
			{
				while (($file = readdir($dh)) !== false)
				{
					if(strpos($file,".") == 0 && substr($file,0,1) != ".")
					{
						$tmp = $this->FolderImages($dir."/".$file,$tab."\t");	
						$Return = array_merge($tmp, $Return);
					}
					
					$this->Var['y']++;
					if($this->Var['y']==1000) exit; 
					if(in_array(substr($file,strrpos($file,".")+1),array('jpg', 'png', 'jpeg', 'gif'))) 
					{
						$Return[] = $dir . "/" .$file;
					}
				}
				closedir($dh);
			}
		}

		return $Return;

	}

	function strip_chars($str)
	{
		$patterns = array('/\//', '/\-/', '/\^/', '/\./', '/\$/', '/\|/', '/\(/', '/\)/', '/\[/', '/\]/', '/\*/', '/\+/', '/\?/', '/\{/', '/\}/', '/\,/');
		$replace = preg_replace($patterns, ' ', $str);

		while($this->str_contains($replace, '  '))
			$replace = str_replace('  ', ' ');

		$replace = str_replace('_', ' ', $replace);
		$replace = strip_tags($replace);

		return $replace;
	}

	//------------------------------------------------
	// Aspect ratio of images
	//------------------------------------------------

	function Ratio($Width,$Height) 
	{
		$Ratio = $Width / $Height;
		$Ratio2 = $Height / $Width;

		for($x = 2; $x<= 10; $x++) 
		{
			$tmpRat = $Ratio*$x;
			$len = strlen(substr($tmpRat, strpos($tmpRat, ".")+1));
			if ($len == 0) break;
		}

		if ($x != 10)
			$Ratio = round(($Ratio*$x),1).":".round(($Ratio*$x*$Ratio2),1);

		return $Ratio;
	}

	//------------------------------------------------
	// Resize images
	//------------------------------------------------

	function resizeImage($file,$filename,$newwidth=160,$newheight=120)
	{
		$type = substr($file,strrpos($file,".")+1);

		switch($type) 
		{
			case 'jpg':
				$src = imagecreatefromjpeg($file);
				break;
			case 'jpeg':
				$src = imagecreatefromjpeg($file);
				break;
			case 'gif':
				$src = imagecreatefromgif($file);
				break;
			case 'png':
				$src = imagecreatefrompng($file);
				break;
			default:
				$src = imagecreatefromjpeg($file);
				break;
		}

		list($width,$height)=getimagesize($file);
		$tmp=imagecreatetruecolor($newwidth,$newheight);
		imagecopyresampled($tmp,$src,0,0,0,0,$newwidth,$newheight,$width,$height);

		switch($type) {
			case 'jpg':
				imagejpeg($tmp,$filename,100);
				break;
			case 'jpeg':
				imagejpeg($tmp,$filename,100);
				break;
			case 'gif':
				imagegif($tmp,$filename,100);
				break;
			case 'png':
				imagepng($tmp,$filename,9);
				break;
			case 'wbm':
				imagewbmp($tmp,$filename,100);
				break;
			default:
				imagejpeg($tmp,$filename,100);
				break;
		}
		imagedestroy($src);
		imagedestroy($tmp);
		return true;
	}


}

