<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: template
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 15 2010
|	> Revisions: 1
|
+--------------------------------------------------------------------------
*/

class template
{
    var $Wall;
    
    function LoadTemplate($Template, $Var=array(), $debug = false)
    {
		// Merge the lang file and settings with the array
		if(! is_array($Var))
			$Var = array();

		if(is_array($this->Wall->lang->Phrase))
			$Var = array_merge($Var, $this->Wall->lang->Phrase);

		if(is_array($this->Wall->Settings))
			$Var = array_merge($Var, $this->Wall->Settings);

		// Debug
		if ($debug === true) {
			print_r($Var);
			exit;
		}

		$Templatez = $this->Wall->Settings['Template'];
		$Templatez .= substr($Templatez, -1) == '/' ? null : '/';

        $Path = $Templatez . "templates/" . $Template;
        
        if ( ! file_exists( $Path ) ) {
            Wallpaper::Error($this->Wall->lang->Phrase['template_noexist']."\n\n".$Template);
        }

		if(functions::str_contains($Template, ".html") == false && Functions::str_contains($Template, ".cphp") == false)
			$Template .= ".cphp";

		//-----------------------------------------------------------
		// Execute plugin code for the template
		//-----------------------------------------------------------
		
		$Source = file_get_contents( $Path );
		$PTemplate = str_ireplace( array('.cphp', '.html'), null, $Template );
		
		if( isset($this->Wall->Plugins[$PTemplate]) ) {
			foreach( $this->Wall->Plugins[$PTemplate] as $Plugin ) {
				eval( $Plugin['code'] );
			}
		}

		$return = $Source;

		if(is_array($Var) && count($Var) > 0)
		{
			foreach ($Var as $identifier => $value)
				$return = str_replace( array('&&' . $identifier . '&&', '{' . $identifier . '}') , $value , $return);
		}

		// Replace PHP code
		while(functions::str_contains($return, '<php>', true) == true)
		{
			$Code = functions::GetStringBetween($return, '<php>', '</php>');

			// Whether the variable is in there or not.
			$php = null;
			$Exec = (functions::str_contains($Code, '$php') == false) ? '$php = ' . $Code : $Code;

			//-------------------------------------------------------
			// Start edits v1.1.2
			// Error handling on eval statements.
			//-------------------------------------------------------

			// Enable output buffering.
			ob_start();

			// Evaluate code as PHP
			eval( $Exec );

			// Retrieve contents of the output buffer. Once done, disable output buffering.
			$ret = ob_get_contents();

			// Did we encounter any errors?
			if ( preg_match( "/Parse error/" , $ret ) ) {

				// Find the specific line
				if( stristr( $ret, 'on line <b>' ) !== false ) {
					preg_match( '/on line \<b\>(.*?)\<\/b\>/', $ret, $Res );
					$Line = isset( $Res[1] ) ? intval( str_replace( ',', '', $Res[1] ) ) : -1;
					
					if( $Line >= 0 ) {
						// Determine what is on that line
						$Lines = array_map( "trim", explode( "\n", $Exec ) );
						$LineContent = isset( $Lines[ $Line - 1 ] ) ? $Lines[ $Line - 1 ] : null;
					}
					
				} else $Line = -1;

				// Array to debug
				$Debug =  array(
					"type"			=> "Template eval parse error",
					"file"			=> __FILE__,
					"template"		=> $Template,
					"description"	=> strip_tags( trim( $ret ) ),
					"code"			=> $Exec,
				);
				
				// Is there a specific line?
				if( $Line !== -1 ) $Debug['line'] = $Line;
				if( isset( $LineContent ) && ! is_null( $LineContent ) ) $Debug['line_content'] = $LineContent;

				// Add debug data
				$this->Wall->Debug->addData( $Debug );

				$ret = null;
			} 

			ob_end_clean();

			//-------------------------------------------------------
			// End debug edits for v1.1.2
			//-------------------------------------------------------

			$return = str_replace('<php>' . $Code . '</php>', $php, $return);
		}

		// Replace all of the other {keywords}
		preg_match_all( "/\{(\w+)\}/", $return, $rem );
		if( count( $rem[0] ) > 0 ) {
			foreach( $rem[0] as $remove ) {
				$return = str_replace( $remove, null, $return );
			}
		}

		return $return;
	}

	//---------------------------------------------------------------
	// Name: executePHP	
	// Desc: Execute (eval) PHP code, if there is an error, capture it.
	//---------------------------------------------------------------
	
	public static function executePHP( $Code )
	{
		// Enable output buffering.
		ob_start();

		// Evaluate code as PHP
		eval( $Code );

		// Retrieve contents of the output buffer. Once done, disable output buffering.
		$ret = ob_get_contents();
		ob_end_clean();

		// Did we encounter any errors?
		if ( preg_match( "/Parse error/" , $ret ) ) {
			print "ERROR";
			exit;
		}

	}
        
}

?>