<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: View
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class View
{
	var $class;
	var $return = array();

	function run()
	{
		$this->return['path'] = "../";

		$Wallpaper = $this->class->Data("wallpaper");
		$Filetype = substr($Wallpaper, strrpos($Wallpaper, ".") + 1, strlen($Wallpaper));
		$Path = "wallpapers/" . $Wallpaper;

		if($Wallpaper == null)
			$this->class->Error('no_wper');

		if(! file_exists($Path))
			$this->class->Error('wallpaper_noexist');

		// Watermark or simply load image?
		if($this->class->Settings['watermark_enabled'] == 1)
		{
			$File = 'etc/cache/' . $Wallpaper;

			// Let's see if it does exist
			if( file_exists($File))
			{
				// Yes, do we need to update?
				$LastModified = filemtime($File);
				$LastWatermark = (int) $this->class->Settings['watermark_last_edit'];

				if($LastModified < $LastWatermark)
					$Image = null;
				else $Image = $File;
				
			}

			// Does the image exist? If not, create it!
			if(! file_exists($File) || $Image == null)
			{
				switch( strtolower( $Filetype ) ) 
				{
					case 'jpg':
					case 'jpeg':
						$im = imagecreatefromjpeg($Path);
						break;
					case 'gif':
						$im = imagecreatefromgif($Path);
						break;
					case 'png':
						$im = imagecreatefrompng($Path);
						break;
					default:
						$im = imagecreatefromjpeg($Path);
						break;
				}

				// Sort out the font path
				$Font = $this->class->Settings['watermark_font'];
				if(substr($Font, 0, 1) == ' ') $Font = substr($Font, 1, strlen($Font));

				$FontPath = 'etc/fonts/' . $Font;

				if(! file_exists($FontPath))
					$this->class->Error($this->class->lang->Phrase['font_noexist'] . ' (' . $FontPath . ')');

				// Sort out the color
				$color = $this->class->Settings['watermark_color'];
				if(substr($color, 0, 1) == '#') $color = substr($color, 1, strlen($color));

				// Get the font position
				if($this->class->Settings['watermark_position'] == '1')
				{
					$size = getimagesize($Path);
					$Height = $size[1];
					$Pos = $Height - 10;
				} else $Pos = 40;

				$clr = imagecolorallocate($im, hexdec('0x' . $color{0} . $color{1}), hexdec('0x' . $color{2} . $color{3}), hexdec('0x' . $color{4} . $color{5}));

				imagettftext($im, intval($this->class->Settings['watermark_font_size']), 0, 10, $Pos, $clr, $FontPath, $this->class->Settings['watermark_text']);

				// Let's move the image
				switch(strtolower($Filetype))
				{
					case 'jpeg':
					case 'jpg':
						imagejpeg($im, $File);
						break;
					case 'gif':
						imagegif($im, $File);
						break;
					case 'png':
						imagepng($im, $File);
						break;
					default:
						imagejpeg($im, $File);
						break;
				}
				
				$Image = $File;
			}
		} else $Image = $Path;

	
		switch(strtolower($Filetype))
		{
			case 'jpeg':
			case 'jpg':
				header('Content-Type: image/jpeg');
				break;
			case 'gif':
				header('Content-Type: image/gif');
				break;
			case 'png':
				header('Content-Type: image/png');
				break;
			default:
				header('Content-Type: image/jpeg');
				break;
		}

		$Img = file_get_contents($Image);

		echo $Img;
		exit;

	}


}


?>