<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Display
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Display
{
	var $class;
	var $return = array();
	var $Output;
	var $Wallpaper;

	var $CommentsPerPage;
	var $commentSunk;

	function run()
	{

		$this->CommentsPerPage = $this->class->Settings['wallpaper_comments_per_page'];
		$this->commentSunk = $this->class->Settings['rating_sunk'];

		$this->return['path'] = "../";
		$commentHTML = null;

		// Variables
		$Pages = null;
		$pagination_html = null;
		$tag = null;
		$starHTML = null;

		// Categories
		$this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
		$this->Output .= $this->class->CompileCategories();
		$this->Output .= $this->class->CompilePartners();
		$this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);

		//-------------------------------------------------------
		// Lets get the different wallpaper uploads
		//-------------------------------------------------------

		$Query = "SELECT * FROM `wallpaper_uploads` WHERE `wid`='".$this->class->Data("id")."' ORDER BY (`width` * `height`) ASC";
		$Res = $this->class->mysql->Query($Query);
		$Sizes = $this->class->mysql->FetchResults($Res);
		
		$sizes = null;
		foreach($Sizes as $Row)
		{
			$sizes .= $this->class->template->LoadTemplate("display/sizes_display.cphp", array(
					"width" => $Row['width'],
					"height" => $Row['height'],
					"url" =>  $this->return['path'].$Row['url'],
					"wid" => $this->class->Data("id"),
			));
		}

		//-------------------------------------------------------
		// Retrieve the wallpaper details
		//-------------------------------------------------------

		$Query = "SELECT *, wallpapers.name, wallpapers.desc, wallpapers.views, wallpapers.votes, wallpapers.votecount, wallpapers.tags, categories.id AS origID, wallpapers.id AS wallID, categories.name as catName, categories.id as catID, wallpapers.author, wallpapers.time FROM `wallpapers` INNER JOIN `categories` ON wallpapers.cat = categories.id WHERE wallpapers.id='".$this->class->Data("id")."' LIMIT 1";

		$Res = $this->class->mysql->Query($Query);
		$Sizes = $this->class->mysql->FetchResults($Res);
		
		// Get the wallpaper into an array
		if(array_key_exists(0, $Sizes)) $this->Wallpaper = $Sizes[0];

		if (count($this->Wallpaper) == 0)
			$this->class->Error("That wallpaper does not exist.");

		// Are we able to view this wallpaper?
		if ($this->Wallpaper['status'] == 0)
			$this->class->Error("wall_unnaproved");

		//-------------------------------------------------------
		// Sort out similar wallpapers
		//-------------------------------------------------------

		if($this->class->Settings['show_similar_wallpapers'] == '1')
		{

			$Query = "SELECT * FROM `wallpapers` WHERE `cat`='".$this->Wallpaper['cat']."' AND `id` != ".$this->Wallpaper['wallID']." ORDER BY RAND() LIMIT 3";
			
			$Res = $this->class->mysql->Query($Query);
			$sWallpapers = $this->class->mysql->FetchResults($Res);

			if (count($sWallpapers) == 0)
			{
				$Query = "SELECT * FROM `wallpapers` WHERE `id` != ".$this->Wallpaper['wallID']." ORDER BY RAND() LIMIT 3";
			
				$Res = $this->class->mysql->Query($Query);
				$sWallpapers = $this->class->mysql->FetchResults($Res);
			}

			$Cat = $this->Wallpaper['catName'];
			$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $Cat)));

			$similar = null;
			foreach($sWallpapers as $Wall)
			{
				// Display a similar wallpaper
				$similar .= $this->class->template->LoadTemplate("display/similar_wallpaper.cphp", array(
						"title" => $Wall['name'],
						"alt" => $Wall['desc'],
						"name" => $CatUrl . "/" . utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $Wall['name']))),
						"path" => $this->return["path"],
						"thumbnail" => $this->return["path"].$Wall['thumbSmall'],
						"wid" => $Wall['id'],
				));
			}
		}

		//-------------------------------------------------------
		// Lets get wallpaper comments
		//-------------------------------------------------------

		if($this->class->Settings['comments_on_wallpaper'] == 1)
		{

			// Get amount of comments
			$Query = "SELECT COUNT(*) FROM `comments` WHERE `wid` = ".$this->class->Data("id")." AND `parent_id` = 0";
			$Res = $this->class->mysql->Query($Query);
			$Amount = $this->class->mysql->FetchResults($Res);
			$Amount = $Amount[0]["COUNT(*)"];

			$Query = "SELECT * FROM `comments` WHERE `wid` = ".$this->class->Data("id")." AND `parent_id` = 0 ORDER BY `time` DESC LIMIT 0,".$this->CommentsPerPage;
			$Res = $this->class->mysql->Query($Query);
			$Comments = $this->class->mysql->FetchResults($Res);
			
			if(count($Comments) == 0)
			{
				// There are 0 comments
				$commentHTML = $this->class->lang->Phrase['wall_nocomments'];
			} else
			{
				// Lets figure out the pagination
				$Pages = ceil($Amount / $this->CommentsPerPage);
				if($Pages == 1)
				{
					$pagHTML = $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => 1));
				} elseif ($Pages == 2 || $Pages == 3)
				{
					$pagHTML = $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => 1));
					for($x = 2; $x <= $Pages; $x++)
					{
						$pagHTML .= $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => $x));
					}
				} elseif ($Pages > 3)
				{
					$pagHTML = $this->class->template->LoadTemplate("display/comment_selpage.cphp", array("page" => 1));
					for($x = 2; $x <= 3; $x++)
					{
						$pagHTML .= $this->class->template->LoadTemplate("display/comment_page.cphp", array("page" => $x));
					}
					$pagHTML .= $this->class->template->LoadTemplate("display/comment_morepages.cphp", array());
				}

				// Output the comments
				$ide = 0;
				foreach($Comments as $Comment)
				{
					$time = $this->class->functions->TimeAgo($Comment['time']);
					
					if($Comment['uid'] == '-1')
					{
						// It's a guest.
						$User = $this->class->template->LoadTemplate("display/comment_guest.cphp", array());
					} else
					{
						$User = $this->class->template->LoadTemplate("display/comment_user.cphp", array(
							"path"		=> $this->return['path'],
							"user_url"	=> utf8_encode(str_replace(" ", $this->class->Settings['identifier'], $Comment['user'])),
							"user"		=> $Comment['user'],
						));
					}

					// Figure out the rating color and font-weight
					$color = (intval($Comment['rating']) < 0) ? "#FF3333" : "#000000";
					$Weight = (intval($Comment['rating']) < 0 || intval($Comment['rating']) > 0) ? "bold" : 0;
					if (intval($Comment['rating']) > 0) {
						$color = "#77AB49";
					}

					// Has the user rated this comment already?
					$checkQuery = "SELECT * FROM `comment_ratings` WHERE `cid`='".$Comment['id']."' AND `ip`='".$this->class->IPAddr()."'";
					$checkRes = $this->class->mysql->Query($checkQuery);
					$Check = $this->class->mysql->FetchResults($checkRes);
					if (count($Check) == 0)
					{
						// Hasn't rated.
						$rHTML = $this->class->template->LoadTemplate("display/rating.cphp", array("cid" => $Comment['id']));
					} else
					{
						// Has rated.
						if ($Check[0]['type'] == 'p')
						{
							// Positive
							$rHTML = $this->class->template->LoadTemplate("display/rating_p.cphp", array());
						} else
						{
							// Negative
							$rHTML = $this->class->template->LoadTemplate("display/rating_n.cphp", array());
						}
					}

					// If the comment has been sunk
					if (intval($Comment['rating']) <= $this->commentSunk)
					{
						$commentHTML .= $this->class->template->LoadTemplate("display/comment_sunk.cphp", array(
							"path"		=> $this->return['path'],
							"user_url"	=> utf8_encode(str_replace(" ", $this->class->Settings['identifier'], $Comment['user'])),
							"user"		=> $Comment['user'],
							"message"	=> $Comment['comment'],
							"time"		=> $time[0]." ".$time[1],
							"userHTML"	=> $User,
							"cid"		=> $Comment['id'],
							"xid"		=> $ide,
							"color"		=> $color,
							"rating"	=> $Comment['rating'],
							"weight"	=> $Weight,
							"rhtml"		=> $rHTML,
						));
					} else
					{
						$commentHTML .= $this->class->template->LoadTemplate("display/comment.cphp", array(
							"path"		=> $this->return['path'],
							"user_url"	=> utf8_encode(str_replace(" ", $this->class->Settings['identifier'], $Comment['user'])),
							"user"		=> $Comment['user'],
							"message"	=> $Comment['comment'],
							"time"		=> $time[0]." ".$time[1],
							"userHTML"	=> $User,
							"cid"		=> $Comment['id'],
							"color"		=> $color,
							"rating"	=> $Comment['rating'],
							"weight"	=> $Weight,
							"rhtml"		=> $rHTML,
						));
					}

					//---------------------------
					// Get child comments
					//---------------------------

					$Query = "SELECT * FROM `comments` WHERE `parent_id`='" . $Comment['id']."'";
					$Result = $this->class->mysql->Query($Query);
					$Subcomments= $this->class->mysql->FetchResults($Result);
					
					foreach($Subcomments as $subComment)
					{
						$ide++;
						// Has the user rated this comment already?
						$checkQuery = "SELECT * FROM `comment_ratings` WHERE `cid`='".$subComment['id']."' AND `ip`='".$this->class->IPAddr()."'";
						$checkRes = $this->class->mysql->Query($checkQuery);
						$Check = $this->class->mysql->FetchResults($checkRes);
						if (count($Check) == 0)
						{
							// Hasn't rated.
							$rHTML = $this->class->template->LoadTemplate("display/rating.cphp", array("cid" => $subComment['id']));
						} else
						{
							// Has rated.
							if ($Check[0]['type'] == 'p')
							{
								// Positive
								$rHTML = $this->class->template->LoadTemplate("display/rating_p.cphp", array());
							} else
							{
								// Negative
								$rHTML = $this->class->template->LoadTemplate("display/rating_n.cphp", array());
							}
						}

						// Figure out the rating color and font-weight
						$color = (intval($subComment['rating']) < 0) ? "#FF3333" : "#000000";
						$Weight = (intval($subComment['rating']) < 0 || intval($subComment['rating']) > 0) ? "bold" : 0;
						if (intval($subComment['rating']) > 0) {
							$color = "#77AB49";
						}

						$time = $this->class->functions->TimeAgo($subComment['time']);
					
						if($subComment['uid'] == '-1')
						{
							// It's a guest.
							$User = $this->class->template->LoadTemplate("display/comment_guest.cphp", array());
						} else
						{
							$User = $this->class->template->LoadTemplate("display/comment_user.cphp", array(
								"path"		=> $this->return['path'],
								"user_url"	=> utf8_encode(str_replace(" ", $this->class->Settings['identifier'], $subComment['user'])),
								"user"		=> $subComment['user'],
							));
						}

						if (intval($subComment['rating']) <= $this->commentSunk)
						{
							$commentHTML .= $this->class->template->LoadTemplate("display/subcomment_sunk.cphp", array(
								"path"		=> $this->return['path'],
								"user_url"	=> utf8_encode(str_replace(" ", $this->class->Settings['identifier'], $Comment['user'])),
								"user"		=> $subComment['user'],
								"message"	=> $subComment['comment'],
								"time"		=> $time[0]." ".$time[1],
								"userHTML"	=> $User,
								"cid"		=> $subComment['id'],
								"xid"		=> $ide,
								"color"		=> $color,
								"rating"	=> $subComment['rating'],
								"weight"	=> $Weight,
								"rhtml"		=> $rHTML,
							));
						} else
						{
							$commentHTML .= $this->class->template->LoadTemplate("display/subcomment.cphp", array(
								"path"		=> $this->return['path'],
								"user_url"	=> utf8_encode(str_replace(" ", $this->class->Settings['identifier'], $subComment['user'])),
								"user"		=> $subComment['user'],
								"message"	=> $subComment['comment'],
								"time"		=> $time[0]." ".$time[1],
								"userHTML"	=> $User,
								"cid"		=> $subComment['id'],
								"color"		=> $color,
								"rating"	=> $subComment['rating'],
								"weight"	=> $Weight,
								"rhtml"		=> $rHTML,
							));
						}
					}
					$ide++;

				}
			}

			// Retrieve pagination HTML
			$Pages = ($Pages == null) ? 0: $Pages;
			if ($Pages > 1)
			{
				$PrevNext = $this->class->template->LoadTemplate("display/comments_next.cphp", array("next" => 2));
				$pagination_html = $this->class->template->LoadTemplate("display/paghtml.cphp", array(
				"comment_pages" => $pagHTML, "prevnext" => $PrevNext));
			}

		}

		//-------------------------------------------------------
		// Sort out the ratings
		//-------------------------------------------------------

		$Rating = (intval($this->Wallpaper['votes']) > 0) ? round(intval($this->Wallpaper['votecount']) / intval($this->Wallpaper['votes']),1) : 0;

		// Rating - rate down
		$rateHTML = null;
		$RateDown = round($Rating,0);
		$repArray = array("Template" => $this->class->Settings['Template'], "path" => $this->return['path']);
		for($x = 0; $x < 5; $x++)
		{
			if ($RateDown <= $x)
			{	// Positive
				$rateHTML .= $this->class->template->LoadTemplate("display/star_pos.cphp", $repArray);
			} else
			{
				$rateHTML .= $this->class->template->LoadTemplate("display/star_neg.cphp", $repArray);
			}
		}

		// Downloads per day
		$days = $this->class->functions->TimeAgo($this->Wallpaper['time'], true);
		$days = $days['days'];
		$days = ($days == 0) ? 1 : $days;

		$dpd = round(intval($this->Wallpaper['downloads']) / intval($days),1);

		

		//-------------------------------------------------------
		// Sort out the Wallpaper tags
		//-------------------------------------------------------

		$Tags = explode(",",str_replace(" ",null,$this->Wallpaper['tags']));
		foreach($Tags as $val)
		{
			$tag .= $this->class->template->LoadTemplate("display/tag.cphp", array(
						"tag_url" => strtolower($val),
						"tag" => $val,
			));
			$tag .= " ";
		}
		$tag = substr($tag, 0, strlen($tag) - 1);

		//-------------------------------------------------------
		// Output the main page HTML
		//-------------------------------------------------------

		$Categ = utf8_encode(str_replace(" ", $this->class->Settings['identifier'], strtolower($Sizes[0]['catName'])));

		$mainArrayRaw = array(
			"Template"			=> $this->class->Settings['Template'],
			"Wallpaper['title']"=> $this->Wallpaper['name'],
			"name_url"			=> $Categ . "/" . utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $this->Wallpaper['name']))),
			"wid"				=> $this->Wallpaper['wallID'],
			"rating"			=> $Rating,
			"votes"				=> $this->Wallpaper['votes'],
			"lower_cat"			=> strtolower($this->Wallpaper['catName']),
			"cat"				=> $this->Wallpaper['catName'],
			"catID"				=> $this->Wallpaper['catID'],
			"url"				=> $this->class->URL,
			"desc"				=> $this->Wallpaper['desc'],
			"urlTitle"			=> urlencode($this->Wallpaper['name']),
			"urlDesc"			=> urlencode($this->Wallpaper['desc']),
			"thumb"				=> $this->Wallpaper['thumbLarge'],
			"stars"				=> $rateHTML,
			"similar"			=> $similar,
			"commentHTML"		=> $commentHTML,
			"image"				=> $this->class->URL.$this->Wallpaper['thumbLarge'],
			"downloads"			=> number_format($this->Wallpaper['downloads']),
			"dpday"				=> $dpd,
			"paghtml"			=> $pagination_html,
			"wallpaper"			=> serialize($this->Wallpaper),
			"tag"				=> $tag,
		);

		$mainArray = array_merge($mainArrayRaw, $this->class->lang->Phrase, $this->class->Settings);
		$this->Output .= $this->class->template->LoadTemplate("display/main.cphp", $mainArray);

		//-------------------------------------------------------
		// Get the user's rating
		//-------------------------------------------------------

		$Query = "SELECT * FROM `votes` WHERE `wid` = ". $this->Wallpaper['wallID']." AND `ip` = '" . $this->class->IPAddr()."'";
		$Result = $this->class->mysql->Query($Query);
		$Votes = $this->class->mysql->FetchResults($Result);
		if(array_key_exists('rating', $Votes))
			$userRating = $Votes[0]['rating'];
		else $userRating = 0;

		for($x = 1; $x <= 5; $x++)
		{
			$type = ($userRating < $x) ? 2 : 3;
			$starHTML .= $this->class->template->LoadTemplate("display/star.cphp", array(
				"wid"		=> $this->Wallpaper['wallID'],
				"num"		=> $x,
				"path"		=> $this->return['path'],
				"Template"	=> $this->class->Settings['Template'],
				"type"		=> $type,
			));
		}

		$userRating = intval($userRating);

		//-------------------------------------------------------
		// Output the HTML for the right side column
		//-------------------------------------------------------

		$this->Output .= $this->class->template->LoadTemplate("display/sizes.cphp", array(
					"path"			=> $this->return['path'], 
					"available_sizes"	=> $this->class->lang->Phrase['available_sizes'], 
					"desc"			=> $this->class->Settings['home_desc'], 
					"Template"		=> $this->class->Settings['Template'],
					"sizes"			=> $sizes,
					"lower_cat"		=> strtolower($this->Wallpaper['catName']),
					"cat"			=> $this->Wallpaper['catName'],
					"catID"			=> $this->Wallpaper['catID'],
					"author"		=> $this->Wallpaper['author'] == null ? "Guest" : $this->Wallpaper['author'],
					"author_link"	=> $this->Wallpaper['author'] == null ? "guest" : utf8_encode(strtolower(str_replace(array(' '), '-', $this->Wallpaper['author']))),
					"views"			=> number_format($this->Wallpaper['views']),
					"date"			=> date("d M Y", $this->Wallpaper['time']),
					"tag"			=> $tag,
					"wid"			=> $this->Wallpaper['wallID'],
					"rating"		=> $userRating,
					"stars"			=> $starHTML,
		));

		// Page details
		$this->class->page['title'] = $this->class->Settings['wallpaper_page_title'];
		$this->class->page['title'] = str_replace('(website)', $this->class->Settings['Site_Title'], $this->class->page['title']);
		$this->class->page['title'] = str_replace('(wallpaper)', $this->Wallpaper['name'], $this->class->page['title']);
		// Update the views
		$this->UpdateViews();
		
		return $this->Output;
	}

	//---------------------------------------
	// Update Page Views
	//---------------------------------------
	
	function UpdateViews()
	{
		$Query = "UPDATE `wallpapers` SET `views`='".(intval($this->Wallpaper['views']) + 1)."' WHERE `id`='".$this->Wallpaper['wallID']."'";
		$Result = $this->class->mysql->Query($Query);
		return true;
	}

}

?>